

function initFilter(){
    
    
    //loadFilterValuesContrast();
    $( "#filter-sliders-contrast" ).slider({
      value:1,
      min: 0,
      max: 2,
      step: 0.1,
      slide: function( event, ui ) {
        changeContrastSlider(ui.value);
      }
    });
    changeContrastSlider(1);
    // Code that uses jQuery's $ can follow here.
    
    $( "#filter-sliders-brightness" ).slider({
      value:0,
      min: -50,
      max: 50,
      step: 1,
      slide: function( event, ui ) {
        changeBrightnessSlider(ui.value);
      }
    });


}

function changeContrastSlider(value){
    $("#imagecanvas").show();
    $("#image").hide();
    var image = $("#image");
  image.canvasEffect({"effect": "contrast", "insert": null,"value": value, "canvas" : $("#imagecanvas").get(0)});
}

function changeBrightnessSlider(value){
    $("#imagecanvas").show();
    $("#image").hide();
    var image = $("#image");
  image.canvasEffect({"effect": "luminosity", "insert": null,"value": value, "canvas" : $("#imagecanvas").get(0)});
}

/*
 * 
 function init(){
	filters = $.fn.jsManipulate("getFilters");
        
	$(":checkbox").checkbox();
	var timeSlider = $("#time-slider").slider({
		animate: "fast",
		min: 0,
		max: 5000,
		step: 100,
		value: defaultTime,
		change: function() {
			$("#time-input").attr({value: $(this).slider("option","value") });	
		}
	});
	var stepsSlider = $("#steps-slider").slider({
		animate: "fast",
		min: 0,
		max: 100,
		value: defaultSteps,
		step: 1,
		change: function() {
			$("#steps-input").attr({value: $(this).slider("option","value") });	
		}
	});
	$("#time-input").attr({value: defaultTime}).change(function(){timeSlider.slider({value:$(this).attr("value")});});
	$("#steps-input").attr({value: defaultSteps}).change(function(){stepsSlider.slider({value:$(this).attr("value")});});
	$("#image").jsManipulate("convert", function(can){ canvas=can});
	fillFilterList();  
	$("#filter-select")[0].value = "twirl";
	loadFilterValues(); 
	$("#direction-select, #filter-select").selectmenu();
	$("#direction-select").selectmenu("disable");
	$("#easing-select").selectmenu({change: function(){ easeSelected = true; }});
	$("#apply-button").click(function(){ applyFilter("apply");});
	$("#animate-button").click(function(){ applyFilter("animate");});
}

*/

/*
function fillFilterList(){ // Brightness
	for(var filter in filters){
		if(filters.hasOwnProperty(filter)){
			$("<option>").attr({value : filter}).html(filters[filter].name).appendTo("#filter-select");
		}
	}
	$("#filter-select").change(loadFilterValues);
}
function fillFilterListContrast(){ // Contrast
	for(var filter in filtersContrast){
		if(filtersContrast.hasOwnProperty(filter)){
			$("<option>").attr({value : filter}).html(filtersContrast[filter].name).appendTo("#filter-select-contrast");
		}
	}
	$("#filter-select-contrast").change(loadFilterValuesContrast);
}

/*
function fillFilterListRBG(){ //RBG
	for(var filter in filtersRBG){
		if(filtersRBG.hasOwnProperty(filter)){
			$("<option>").attr({value : filter}).html(filtersRBG[filter].name).appendTo("#filter-select-rbg");
		}
	}
	$("#filter-select-rbg").change(loadFilterValuesRBG);
}

*/

function loadFilterValues(){
	var filter = filters[$("#filter-select")[0].value];
	var sliderParent = $("#filter-sliders");
	sliderParent[0].innerHTML = "";
	if(filter === undefined){
		return;
	}
	filterValues = $.extend({},filter.defaultValues);
	var filterRanges = filter.valueRanges;
	
	
	for(var value in filterValues){
		if(filterValues.hasOwnProperty(value)){
			var valueStr = String(value).substring(0,1).toUpperCase() + String(value).substring(1);
			$("<div>").attr({id: "value-type"}).addClass("Brightness").html("Brightness").appendTo(sliderParent);
			if( typeof filterValues[value] === "boolean"){
				var checkbox = $("<input>").attr({type: "checkbox", checked: filterValues[value], name: value});
				checkbox.appendTo(sliderParent);	
				checkbox.checkbox();
				checkbox.click(function() { filterValues[value] = Boolean(this.checked);});
			} else {
				var min = filterRanges[value].min;
				var max = filterRanges[value].max;
				var valDiff = max-min;
				var stepSize;
				if(valDiff <= 4){
					stepSize = 0.01;
				} else if(valDiff <= 10){
					stepSize = 0.1;
				} else {
					stepSize = 1;
				}
                                
                                
                //var newline = $("<br/><br/>");
                //var inputButtons = $("<div></div>").attr({style:"margin-left: 50px;"});
                //var inputDec = $("<img>").addClass("input-button-inline").attr({src:"/assets/img/minus-48.png", id:value+"-inputDec", width:"40", height:"40", style:"float:left"});
                //var inputInc = $("<img>").addClass("input-button-inline").attr({src:"/assets/img/plus-48.png", id:value+"-inputInc",  width:"40", height:"40"});
                //var inputText = $("<input>").addClass("text-input").attr({id:value+"-input", type: "text", value: filterValues[value]});
				var inputSlider = $("<div>").addClass("slider").attr({id:value+"-slider"}).slider({
					min: min,
					max: max,
					value: filterValues[value],
					step: stepSize,
					animate: "fast",
					change: function(){
						updateValue(this.id,$(this).slider("option","value"));
                                                applyAllFilters();
					}
				});
				/*
                inputText.change(function(){
					updateValue(this.id,this.value);
				});
                                
                inputDec.click(function(){
                    inputDecrement(this.id);
                    applyAllFilters();
                });
                inputInc.click(function(){
                    inputIncrement(this.id);
                    applyAllFilters();
                });
                */
                //inputDec.appendTo(inputButtons);
                //inputText.appendTo(inputButtons);
                //inputInc.appendTo(inputButtons);
                                
				inputSlider.appendTo(sliderParent);
                //newline.appendTo(sliderParent);
                //inputButtons.appendTo(sliderParent);
			}
		}
	}
	var smParam = filter.isDirAnimatable? "enable" : "disable";
	$("#direction-select").selectmenu(smParam);
}


function loadFilterValuesContrast(){
	var filter = "none";
	var sliderParent = $("#filter-sliders-contrast");
	sliderParent[0].innerHTML = "";
	if(filter === undefined){
		return;
	}
	filterValuesContrast = $.extend({},filter.defaultValues);
	var filterRanges = filter.valueRanges;
    
    var min = filterRanges[value].min;
    var max = filterRanges[value].max;
    var valDiff = max-min;
    var stepSize;
    if(valDiff <= 4){
        stepSize = 0.01;
    } else if(valDiff <= 10){
        stepSize = 0.1;
    } else {
        stepSize = 1;
    }


    var inputSlider = $("<div>").addClass("slider").attr({id:value+"-slider"}).slider({
        min: min,
        max: max,
        value: filterValuesContrast[value],
        step: stepSize,
        animate: "fast",
        change: function(){
            changeContrastSlider($(this).slider("option","value"));
        }
    });


    inputSlider.appendTo(sliderParent);
	
	
	
}

/*
function loadFilterValuesRBG(){
	var filter = filtersRBG[$("#filter-select-rbg")[0].value];
	var sliderParent = $("#filter-sliders-rbg");
	sliderParent[0].innerHTML = "";
	if(filter === undefined){
		return;
	}
	filterValuesRBG = $.extend({},filter.defaultValues);
	var filterRanges = filter.valueRanges;
	
	
	for(var value in filterValuesRBG){
		if(filterValuesRBG.hasOwnProperty(value)){
			var valueStr = String(value).substring(0,1).toUpperCase() + String(value).substring(1);
			$("<div>").attr({id: "value-type"}).addClass("slider-title").html(valueStr).appendTo(sliderParent);
			if( typeof filterValuesRBG[value] === "boolean"){
				var checkbox = $("<input>").attr({type: "checkbox", checked: filterValuesRBG[value], name: value});
				checkbox.appendTo(sliderParent);	
				checkbox.checkbox();
				checkbox.click(function() { filterValuesRBG[value] = Boolean(this.checked);});
			} else {
				var min = filterRanges[value].min;
				var max = filterRanges[value].max;
				var valDiff = max-min;
				var stepSize;
				if(valDiff <= 4){
					stepSize = 0.01;
				} else if(valDiff <= 10){
					stepSize = 0.1;
				} else {
					stepSize = 1;
				}
                                
                                var newline = $("<br/><br/>");
                                var inputButtons = $("<div></div>").attr({style:"margin-left: 50px;"});
                                var inputDec = $("<img>").addClass("input-button-inline").attr({src:"/assets/img/minus-48.png", id:value+"-inputDec", width:"40", height:"40", style:"float:left"});
                                var inputInc = $("<img>").addClass("input-button-inline").attr({src:"/assets/img/plus-48.png", id:value+"-inputInc",  width:"40", height:"40"});
				var inputText = $("<input>").addClass("text-input").attr({id:value+"-input", type: "text", value: filterValuesRBG[value]});
				var inputSlider = $("<div>").addClass("slider").attr({id:value+"-slider"}).slider({
					min: min,
					max: max,
					value: filterValuesRBG[value],
					step: stepSize,
					animate: "fast",
					change: function(){
						updateValue(this.id,$(this).slider("option","value"));
                                                applyAllFilters();
					}
				});
				inputText.change(function(){ 
					updateValue(this.id,this.value);

				});
                                inputDec.click(function(){
                                    inputDecrement(this.id);
                                    applyAllFilters();
                                });
                                inputInc.click(function(){
                                    inputIncrement(this.id);
                                    applyAllFilters();
                                });
                                
                                inputDec.appendTo(inputButtons);
                                inputText.appendTo(inputButtons);
                                inputInc.appendTo(inputButtons);
                                
				inputSlider.appendTo(sliderParent);
                                newline.appendTo(sliderParent);
                                inputButtons.appendTo(sliderParent);
                                //inputDec.appendTo(sliderParent);
				//inputText.appendTo(sliderParent);
                                //inputInc.appendTo(sliderParent);
			}
		}
	}
	var smParam = filter.isDirAnimatable? "enable" : "disable";
	$("#direction-select").selectmenu(smParam);
}
*/

function updateValue(idStr,value){
	if(idStr.indexOf("slider") != -1){
		idStr = idStr.replace("slider","input");
	} else {
		idStr = idStr.replace("input","slider");
	}
	var element = $("#" + idStr);
	var newValue = Math.round(value*100)/100;
	if(element.attr("value")){
		element.attr({value:newValue});
	} else {
		element.slider({value:newValue});	
	}

	filterValues[idStr.substring(0,idStr.indexOf("-"))] = newValue;
}
function resetFilter(){
        updateValue("amount-input",0);
        updateValue("contrastamount-input",0);
        updateValue("red-input",0);
        updateValue("green-input",0);
        updateValue("blue-input",0);
}
/*
function inputIncrement(idStr) {
        // update input value
	idStr = idStr.replace("inputInc","input");
	var element = $("#" + idStr);
        var value = element.val();  // get previous input value
        var newValue = (Math.round(value*100) + 2)/100; // increase 0.02 per click
	element.attr({value:newValue}); // set input value

        // update slider value
        updateValue(idStr, newValue);  
}
function inputDecrement(idStr) {
        // update input value
	idStr = idStr.replace("inputDec","input");
	var element = $("#" + idStr);
        var value = element.val();  // get previous input value
        var newValue = (Math.round(value*100) - 2)/100; // decrease 0.02 per click
	element.attr({value:newValue}); // set input value	

        // update slider value
        updateValue(idStr, newValue);  
}
*/
function applyAllFilters(){
    canvas.jsManipulate("restore"); updateProgressBar(40);
    applyFilter("apply");updateProgressBar(45);
    applyFilterContrast("apply");updateProgressBar(50);
    //applyFilterRBG("apply", "red");updateProgressBar(55);
    //applyFilterRBG("apply", "green"); updateProgressBar(60);
    //applyFilterRBG("apply", "blue"); updateProgressBar(65);
}
function applyFilter(func){

	var selectedFilter =  $("#filter-select")[0].value;
	if(selectedFilter !== "none"){
		var parameters = {
			filter: selectedFilter,
			values: filterValues,
			stack: Boolean($("#stack-check")[0].checked), // if dec value, uncheck stack
			direction: $("#direction-select").selectmenu("value"),
			easing: easeSelected ? $("#easing-select").selectmenu("value") : defaultEase,
			time: $("#time-input")[0].value,
			steps: $("#steps-input")[0].value,
			smoothing: Boolean($("#smooth-check")[0].checked) ? "auto" : 0
		};
		canvas.jsManipulate(func, parameters);
                //canvas_hide.jsManipulate(func, parameters);
		var codeString = "$('#YOUR_ELEMENT_ID_HERE').jsManipulate('" + func + "', { \n" + 
		"    filter: '" + selectedFilter + "'";
		var first = true;
		for(var val in filterValues) {
			if(first) {
				first = false;
				codeString += ", \n    values: { \n";	
			}
			codeString += "        " + val + ": " + filterValues[val] + ",\n";	
		}
		if(!first){
			codeString = codeString.substring(0,codeString.length-2) + "\n    }";	
		}
		if(Boolean($("#stack-check")[0].checked)){
			codeString += ",\n    ";
			codeString += "stack: true";
		}
		if(func === "animate"){
			codeString += ",\n    " + 
			"direction: '" + $("#direction-select").selectmenu("value")+"',\n    " + 
			"easing: '" + (easeSelected ? $("#easing-select").selectmenu("value") : defaultEase) + "',\n    " +
			"time: " + $("#time-input")[0].value +",\n    " +
			"steps: " + $("#steps-input")[0].value +",\n    " +
			"smoothing: " + (Boolean($("#smooth-check")[0].checked) ? "'auto'" : 0) + " //Or any arbitrary integer for specifing number of smoothing segments.";
		}
		codeString += "\n});";
		$(".prettyprint").html(codeString);
		prettyPrint();
	} else {
		canvas.jsManipulate("restore");		
	}
}
function applyFilterContrast(func){

        
	var selectedFilter =  $("#filter-select-contrast")[0].value;
	if(selectedFilter !== "none"){
		var parameters = {
			filter: selectedFilter,
			values: filterValues,
			stack: Boolean($("#stack-check")[0].checked),
			direction: $("#direction-select").selectmenu("value"),
			easing: easeSelected ? $("#easing-select").selectmenu("value") : defaultEase,
			time: $("#time-input")[0].value,
			steps: $("#steps-input")[0].value,
			smoothing: Boolean($("#smooth-check")[0].checked) ? "auto" : 0
		};
		canvas.jsManipulate(func, parameters);
                //canvas_hide.jsManipulate(func, parameters);
		var codeString = "$('#YOUR_ELEMENT_ID_HERE').jsManipulate('" + func + "', { \n" + 
		"    filter: '" + selectedFilter + "'";
		var first = true;
		for(var val in filterValuesContrast) {
			if(first) {
				first = false;
				codeString += ", \n    values: { \n";	
			}
			codeString += "        " + val + ": " + filterValuesContrast[val] + ",\n";	
		}
		if(!first){
			codeString = codeString.substring(0,codeString.length-2) + "\n    }";	
		}
		if(Boolean($("#stack-check")[0].checked)){
			codeString += ",\n    ";
			codeString += "stack: true";
		}
		if(func === "animate"){
			codeString += ",\n    " + 
			"direction: '" + $("#direction-select").selectmenu("value")+"',\n    " + 
			"easing: '" + (easeSelected ? $("#easing-select").selectmenu("value") : defaultEase) + "',\n    " +
			"time: " + $("#time-input")[0].value +",\n    " +
			"steps: " + $("#steps-input")[0].value +",\n    " +
			"smoothing: " + (Boolean($("#smooth-check")[0].checked) ? "'auto'" : 0) + " //Or any arbitrary integer for specifing number of smoothing segments.";
		}
		codeString += "\n});";
		$(".prettyprint").html(codeString);
		prettyPrint();
	} else {
		canvas.jsManipulate("restore");	

	}
}

function applyFilterRBG(func, color){

	var selectedFilter =  $("#filter-select-rbg")[0].value;
	if(selectedFilter !== "none"){
		var parameters = {
			filter: selectedFilter,
			values: filterValues,
			stack: Boolean($("#stack-check")[0].checked),
			direction: $("#direction-select").selectmenu("value"),
			easing: easeSelected ? $("#easing-select").selectmenu("value") : defaultEase,
			time: $("#time-input")[0].value,
			steps: $("#steps-input")[0].value,
			smoothing: Boolean($("#smooth-check")[0].checked) ? "auto" : 0
		};
		canvas.jsManipulate(func, parameters);
                //canvas_hide.jsManipulate(func, parameters);
		var codeString = "$('#YOUR_ELEMENT_ID_HERE').jsManipulate('" + func + "', { \n" + 
		"    filter: '" + selectedFilter + "'";
		var first = true;
		for(var val in filterValuesRBG) {
			if(first) {
				first = false;
				codeString += ", \n    values: { \n";	
			}
			codeString += "        " + val + ": " + filterValuesRBG[val] + ",\n";	
		}
		if(!first){
			codeString = codeString.substring(0,codeString.length-2) + "\n    }";	
		}
		if(Boolean($("#stack-check")[0].checked)){
			codeString += ",\n    ";
			codeString += "stack: true";
		}
		if(func === "animate"){
			codeString += ",\n    " + 
			"direction: '" + $("#direction-select").selectmenu("value")+"',\n    " + 
			"easing: '" + (easeSelected ? $("#easing-select").selectmenu("value") : defaultEase) + "',\n    " +
			"time: " + $("#time-input")[0].value +",\n    " +
			"steps: " + $("#steps-input")[0].value +",\n    " +
			"smoothing: " + (Boolean($("#smooth-check")[0].checked) ? "'auto'" : 0) + " //Or any arbitrary integer for specifing number of smoothing segments.";
		}
		codeString += "\n});";
		$(".prettyprint").html(codeString);
		prettyPrint();
	} else {
		canvas.jsManipulate("restore");	
	
	}
}
 
 
function updateProgressBar(percentage){
   /*
    
    $('#pb div').stop(true).animate({
        width: percentage + '%'
    }, {

        step: function(now) {

            $(this).text(Math.round(now) + '%');
        },
        duration: 1000
    });
    */
}