/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var pagetimeout = null;
var messagetimeout;
var timeouttime = 0;
var secondtimeout = 5000;
var fullscreenTries = 0;
var videoidtocheck = null;
var croppingaspectratio = '4x6';
var currentimageid = null;
var noticed = false;

function notice(msg) {
    $("#alertBox").html(msg);
    if (!noticed) showNotice();
}

function showNotice() {
    noticed = true;
    $("#alertBox").animate({
        "top": "-20px"},
        500, function() {
            setTimeout("hideNotice()",5000);
        });
}

function hideNotice() {
    noticed = false;
    $("#alertBox").animate({
        "top": "-80px"},
        500, function() {
        });
    
}

function showimage(id) {
	resetTimeout();
	currentimageid = id;
    $("#" + id).show();
}

function showvideo(id) {
    resetTimeout();
    $("#" + id).show();
    fullscreenTries = 0;
    tryFullScreen(id);
}

function nextimage(currentid) {
    for (i = 0; i < imagelist.length; i++) {
        if (imagelist[i] == currentid) {
            j = (i < imagelist.length-1) ? j = i+1 : j = 0;
            currentimageid = imagelist[j];
			hideimage(currentid);
			showimage(currentimageid);
		}
	}
}

function previousimage(currentid) {
	for (i = 0; i < imagelist.length; i++) {
		if (imagelist[i] == currentid) {
			if(i > 0) {
				j = i-1;
			} else {
				j = imagelist.length-1;
			}
			currentimageid = imagelist[j];
			hideimage(currentid);
			showimage(currentimageid);
		}
	}
}

function resetScale() {
    jQuery('meta[name=viewport]').attr('content','width=device-width, minimum-scale=1.0, maximum-scale=1.0, initial-scale=1.0, user-scalable=0');
    /*
    var viewportmeta = document.querySelector('meta[name="viewport"]');
    if (viewportmeta) {
        viewportmeta.content = 'width=device-width, minimum-scale=1.0, maximum-scale=1.0, initial-scale=1.0';
        
    }*/
}

function allowScale() {
    jQuery('meta[name=viewport]').attr('content','width=device-width, minimum-scale=1.0, maximum-scale=2.0, initial-scale=1.0, user-scalable=1');
    /*
    var viewportmeta = document.querySelector('meta[name="viewport"]');
    if (viewportmeta) {
        viewportmeta.content = 'width=device-width, minimum-scale=0.5, maximum-scale=2.0, initial-scale=1.0';
    }
    */
}

function setVideo(id) {
    videoidtocheck = id;
}

function tryFullScreen(id) {
    vid = document.getElementById("video" + id);
    if (vid.webkitSupportsFullscreen) {
        vid.play();
        vid.webkitEnterFullscreen();
        //console.log("entering full screen");
    } else {
        //console.log("full screen not supported, trying in another second...");
        if (fullscreenTries < 2) setTimeout("tryFullScreen(" + id + ")", 1000);
    }
    fullscreenTries++;
}

function editimage(id, code) {
    var filepath = $("#filepath" + id).html();
    window.location = "/Edit/" + code + "?filepath=" + filepath + "&id=" + id;
}

function revertimage(id, code) {
    var filepath = $("#filepath" + id).html();
    window.location = "/Revert/" + code + "?filepath=" + filepath;
}

function hideimage(id) {
	resetTimeout();
    $("#" + id).hide();
}

function showpreview(id) {
    resetTimeout();
    $("#preview" + id).show();
    //allowScale();
}

function hidepreview(id) {
    resetTimeout();
    $("#preview" + id).hide();
    //resetScale();
}

function showcartpreview(imagepath) {
    console.log("test");
    $("#cartpreviewimg").attr("src", "/images/image/image.jpg?filename=" + imagepath);
    console.log("cartpreviewimg: " + $("#cartpreviewimg").attr("src"));
    $("#shoppingCart").hide();
    $("#cartpreview").show();
}
function hidecartpreview() {
    //$("#cartpreviewimg").attr("src", "");
    $("#cartpreview").hide();
    $("#shoppingCart").show();
}

function markImage(filepath, id) {
    resetTimeout();
    $("#icon" + id).html("<img src=\"/images/loading.gif\" class=\"flagimg\">");
    $("#full" + id).html("<img src=\"/images/loading.gif\" class=\"fullscreenflagimg\">");
    $.ajax({
        type: "GET", 
        url: "/images/mark",
        data: {filename:filepath},
        dataType: "text",
        success: function(resp) { 
            if (resp === "OK") {
                $("#icon" + id).html("<img src=\"/images/flag-on.png\" class=\"flagimg\" onclick=\"unmarkImage('" + filepath + "','" + id + "')\">");
                $("#full" + id).html("<img src=\"/images/flag-on.png\" class=\"fullscreenflagimg\" onclick=\"unmarkImage('" + filepath + "','" + id + "')\">");
                //console.log("true response: " + resp);
            } else {
                $("#icon" + id).html("<img src=\"/images/flag-off.png\" class=\"flagimg\" onclick=\"markImage('" + filepath + "','" + id + "')\">");
                $("#full" + id).html("<img src=\"/images/flag-off.png\" class=\"fullscreenflagimg\" onclick=\"markImage('" + filepath + "','" + id + "')\">");
                //console.log("false response: " + resp);
            }
        },
        error: function(x,y,z) {
            $("#icon" + id).html("<img src=\"/images/flag-off.png\" class=\"flagimg\" onclick=\"markImage('" + filepath + "','" + id + "')\">");
            $("#full" + id).html("<img src=\"/images/flag-off.png\" class=\"fullscreenflagimg\" onclick=\"markImage('" + filepath + "','" + id + "')\">");
            //console.log("error response");
        }             
    });
}

function unmarkImage(filepath, id) {
    resetTimeout();
    $("#icon" + id).html("<img src=\"/images/loading.gif\" class=\"flagimg\">");
    $("#full" + id).html("<img src=\"/images/loading.gif\" class=\"fullscreenflagimg\">");
    $.ajax({
        type: "GET", 
        url: "/images/unmark",
        data: {filename:filepath},
        dataType: "text",
        success: function(resp) { 
            if (resp === "OK") {
                $("#icon" + id).html("<img src=\"/images/flag-off.png\" class=\"flagimg\" onclick=\"markImage('" + filepath + "','" + id + "')\">");
                $("#full" + id).html("<img src=\"/images/flag-off.png\" class=\"fullscreenflagimg\" onclick=\"markImage('" + filepath + "','" + id + "')\">");
                //console.log("true response: " + resp);
            } else {
                $("#icon" + id).html("<img src=\"/images/flag-on.png\" class=\"flagimg\"onclick=\"unmarkImage('" + filepath + "','" + id + "')\">");
                $("#full" + id).html("<img src=\"/images/flag-on.png\" class=\"fullscreenflagimg\" onclick=\"unmarkImage('" + filepath + "','" + id + "')\">");
                //console.log("false response: " + resp);
            }
        },
        error: function(x,y,z) {
            $("#icon" + id).html("<img src=\"/images/flag-on.png\" class=\"flagimg\" onclick=\"unmarkImage('" + filepath + "','" + id + "')\">");
            $("#full" + id).html("<img src=\"/images/flag-on.png\" class=\"fullscreenflagimg\" onclick=\"unmarkImage('" + filepath + "','" + id + "')\">");
            //console.log("error response");
        }             
    });
}

function pausevid(id) {
    $("#video" + id).get(0).pause();
}

function startTimeout(timeout) {
    timeouttime = timeout * 1000;
    if (timeouttime > 0) pagetimeout = setTimeout("displayTimeoutWarning()",timeouttime);
}

function resetTimeout() {
    clearTimeout(pagetimeout);
    if (timeouttime > 0) pagetimeout = setTimeout("displayTimeoutWarning()",timeouttime);
}

function displayTimeoutWarning() {
    //Check if video is playing
    if (videoidtocheck !== null && !document.getElementById("video" + videoidtocheck).paused) {
        resetTimeout();
    } else {
        $("#timeoutMessage").show();
        messagetimeout = setTimeout("location.href = '/';",secondtimeout);
    }
}

function stillHere() {
    clearTimeout(messagetimeout);
    resetTimeout();
    $("#timeoutMessage").hide();
}

function displayProductTools(boxid, toolid) {
	//determine aspect ratio, then display default tools for that product
	//
	//console.log("showing: " + "#producttools" + id);
	if ($("#src"+boxid).width() > $("#src"+boxid).height()) {
		//Landscape
		//console.log("lsdata: " + $("#landscapebaseproductdata" + toolid).html());
		//console.log("productoptions: " + "#productoptions" + boxid);
		$("#productoptions" + boxid + toolid).html($("#landscapebaseproductdata" + toolid).html());
	} else {
		//Portrait
		//console.log("ptdata: " + $("#portraitbaseproductdata" + toolid).html());
		//console.log("productoptions: " + "#productoptions" + boxid);
		$("#productoptions" + boxid + toolid).html($("#portraitbaseproductdata" + toolid).html());
	}
	
	$("#productsbox" + boxid).hide();
    $("#producttools" + boxid + toolid).show();
}

function closeProductTools(boxid, toolid) {
	$("#productsbox" + boxid).show();
    $("#producttools" + boxid + toolid).hide();
}

function printProduct(imageid, productid) {
    var filepath = $("#filepath" + imageid).html();
    var quantity = $("#quantity" + imageid + productid).html();
    $("#loadingboxcontent").html("Sending to Printer...");
    $("#loadingscreen").show();
	//get Text Data, if Any?
	var textvalue = "";
	var textname = "";
    var layer = "";
	$("#productoptions" + imageid + productid).find("textarea").each(function()
	{
		textvalue = $(this).val();
		textname = $(this).attr("name");
		var textnameparts = textname.split("layer");
        layer = textnameparts[textnameparts.length-1];
	});
    $.ajax({
        type: "POST",
        url: "/api/print",
        processData : true,
        data: {filepath:filepath,
            productid:productid,
            quantity:quantity,
			textvalue:textvalue,
			textlayer:layer
            },
        dataType: "text",
        success: function(response) {                            
            console.log("Response for printcode");
            $("#messageboxcontent").html("Print Job Sent!");
            $("#loadingscreen").hide();
            $("#messagescreen").show();
            closeProductTools(imageid, productid);
            setTimeout("$(\"#messagescreen\").fadeOut()",2000);
        },
        error: function(x,y,z) {
            var html = x.responseText; 
            var msg = $('<div />').append(html).find('p:first').text();
            console.log("We have a response from Set Print Code: "+ x);
            $("#messageboxcontent").html("There was an error printing this image. Please try again.");
            $("#loadingscreen").hide();
            $("#messagescreen").show();
            setTimeout("$(\"#messagescreen\").fadeOut()",2000);
        }
    });
    
}

function addProductToCart(imageid, productid, search) {
    var filepath = $("#filepath" + imageid).html();
    var quantity = $("#quantity" + imageid + productid).html();
    notice("Adding to Cart...");
   // $("#loadingboxcontent").html("Adding to Cart...");
    //$("#loadingscreen").show();
	//get Text Data, if Any?
	var textvalue = "";
	var textname = "";
    var layer = "";
	$("#productoptions" + imageid + productid).find("textarea").each(function()
	{
		textvalue = $(this).val();
		textname = $(this).attr("name");
		var textnameparts = textname.split("layer");
        layer = textnameparts[textnameparts.length-1];
	});
    $.ajax({
        type: "POST",
        url: "/api/addToCart",
        processData : true,
        data: {filepath:filepath,
            productid:productid,
            quantity:quantity,
			textvalue:textvalue,
			textlayer:layer,
            search:search
            },
        dataType: "text",
        success: function(response) {                            
            console.log("Response for printcode");
            //$("#loadingscreen").hide();
            //$("#messagescreen").show();
            notice("Item Added to Cart!");
            getCart();
            closeProductTools(imageid, productid);
            //setTimeout("$(\"#messagescreen\").fadeOut()",2000);
        },
        error: function(x,y,z) {
            var html = x.responseText; 
            var msg = $('<div />').append(html).find('p:first').text();
            console.log("We have a response from Set Print Code: "+ x);
            $("#messageboxcontent").html("There was an error printing this image. Please try again.");
            $("#loadingscreen").hide();
            $("#messagescreen").show();
            setTimeout("$(\"#messagescreen\").fadeOut()",2000);
        }
    });
    
}

function incqty(qtyfield) {
	var qty = $("#quantity" + qtyfield).html();
	qty++;
	$("#quantity" + qtyfield).html(qty);
    
    updateSubtotal(qty, qtyfield);
}

function decqty(qtyfield) {
	var qty = $("#quantity" + qtyfield).html();
	if (qty > 1) {
		qty--;
		$("#quantity" + qtyfield).html(qty);
	}
    updateSubtotal(qty, qtyfield);
}

function updateSubtotal(qty, qtyfield) {
    var price = $("#price" + qtyfield).html();
    var subtotal = price * qty;
    $("#subtotal" + qtyfield).html(subtotal.toFixed(2));
}

function showCart() {
    $("#shoppingCart").show();
}

function closeCart() {
    $("#shoppingCart").hide();
}

function getCart() {
    $("#carttabcount").html("<img src=\"/images/loading.gif\">");
    $.ajax({
        type: "POST",
        url: "/api/getCart",
        processData : true,
        dataType: "xml",
        success: function(response) {                            
            console.log("Response for getcart: " + $(response).text());
            var numitems = "0";
            $(response).find('cart').each(function() {
               numitems = $(this).find('productitems').text();
            });
            
            var cartdata = "";
			var carttotal = 0.00;
            //Cart Data
            $(response).find('items').each(function() {
                $(this).find('data').each(function() {
                    cartdata += "<div class=\"cartRow\">";
                    cartdata += "<div class=\"cartDesc\">";
					var prodinfo = $("#productinfo" + ($(this).find("plucode").text())).find("productname").text();
                    var packageitem = false;
                    if (prodinfo.length < 2) {
                        prodinfo = "Package";
                        if ($(this).find("plucode").text() === "SALESTAX") {
                            prodinfo = "Sales Tax";
                            cartdata += "<div class=\"cartIcon\"><img src=\"/images/cart.png\"></div>";
                        } else {
                            cartdata += "<div class=\"cartIcon\"><img src=\"/images/golden_offer.png\"></div>";
                        }
                        packageitem = true;
                    } else {
                        cartdata += "<div class=\"cartIcon\"><img src=\"/images/image/image.jpg?filename=" + ($(this).find("imagepath").text()) + "\" height=\"100\" onclick=\"showcartpreview('" + ($(this).find("imagepath").text()) + "')\"></div> ";
                    }
                    cartdata += prodinfo;
					cartdata += "<br>";
                    if (!packageitem) cartdata += "<div class=\"button productButtonMicro\"  onclick=\"deleteItem('" + $(this).find("printid").text().trim() + "');\">DELETE</div>";
					cartdata += "</div>";
					
					cartdata += "<div class=\"cartQty\">";
					var productQty = parseInt($(this).find("quantity").text());
					cartdata += $(this).find("quantity").text();
					cartdata += "</div>";
					
					cartdata += "<div class=\"cartPrice\">";
					var productPrice = parseFloat($(this).find("price").text());
					cartdata += "$" + productPrice.toFixed(2);
					cartdata += "</div>";
					
					cartdata += "<div class=\"cartSubtotal\">";
					cartdata += "$" + (productQty * productPrice).toFixed(2);
					carttotal += parseFloat((productQty * productPrice).toFixed(2));
					cartdata += "</div>";
					
					cartdata += "</div>";
                });
            });
			
			cartdata += "<div class=\"carttotal\">";
			cartdata += "<div class=\"cartDesc\">&nbsp;</div>";
			cartdata += "<div class=\"cartQty\">&nbsp;</div>";
			cartdata += "<div class=\"cartPrice\">Total:</div>";
			cartdata += "<div class=\"cartSubtotal\">";
			cartdata += "$";
			cartdata += carttotal.toFixed(2);
			cartdata += "</div></div>";
			
            
            $("#shoppingCartDetails").html(cartdata);
            
            $("#carttabcount").html(numitems);
        },
        error: function(x,y,z) {
            var html = x.responseText; 
            var msg = $('<div />').append(html).find('p:first').text();
            console.log("We have a response from getCart Code: "+ x);
            
        }
    });
}

function deleteCart() {
    //$("#carttabcount").html("<img src=\"/images/loading.gif\">");
    if (confirm("Are you sure you want to delete all items in the cart?")) {
		deleteCartF(false);
	}
}

function deleteCartF(logout) {
    //$("#carttabcount").html("<img src=\"/images/loading.gif\">");
    $("#loadingboxcontent").html("Deleting Cart...");
    $("#loadingscreen").show();

    $.ajax({
        type: "POST",
        url: "/api/deleteCart",
        processData : true,
        dataType: "text",
        success: function(response) {   
            
            $("#loadingscreen").hide();
            notice("Cart Emptied!");
            closeCart();
            getCart();
            if (logout) {
                window.location='/';
            }
        }, 
        error: function(x,y,z) {
            var html = x.responseText; 
            $("#messageboxcontent").html("There was an error deleting your cart.  Please try again!");
            $("#loadingscreen").hide();
            $("#messagescreen").show();
            getCart();
            setTimeout("$(\"#messagescreen\").fadeOut()",5000);
        }
    });
}

function deleteItem(printid) {
	if (confirm("Are you sure you want to delete this item?")) {
		$("#loadingboxcontent").html("Deleting Item...");
		$("#loadingscreen").show();
		$.ajax({
			type: "POST",
			url: "/api/deleteCartItem",
			processData : true,
			dataType: "text",
			data: {printid:printid
				},
			success: function(response) {   
				$("#messageboxcontent").html("Item Deleted!");
				$("#loadingscreen").hide();
				$("#messagescreen").show();
				getCart();
				setTimeout("$(\"#messagescreen\").fadeOut()",2000);
			}, 
			error: function(x,y,z) {
				var html = x.responseText; 
				$("#messageboxcontent").html("There was an error deleting your cart.  Please try again!");
				$("#loadingscreen").hide();
				$("#messagescreen").show();
				getCart();
				setTimeout("$(\"#messagescreen\").fadeOut()",5000);
			}
		});
	}
		
}

function checkoutconfirmation() {
    $("#checkoutconfirmation").show();
}

function checkoutcancelconfirmation() {
    $("#checkoutconfirmation").hide();
}

function checkout() {
	if ($("#releasecodeverify").length && $("#releasecodeverify").val().length > 1) {
		if ($("#releasecodeverify").val() != $("#releasecode").val()) {
            alert("Invalid Release Code!");
            return;
        }
	}
    //$("#carttabcount").html("<img src=\"/images/loading.gif\">");
    $("#checkoutconfirmation").hide();
    $("#loadingboxcontent").html("Checking out...");
    $("#loadingscreen").show();
    var name = $("#cartname").val();
    $.ajax({
        type: "POST",
        url: "/api/checkout",
        processData : true,
        dataType: "text",
        data: {cartname:name
				},
        success: function(response) {   
            $("#messageboxcontent").html("<img src=\"/images/Tick-48.png\"><br><br>Checkout Completed!!");
            $("#loadingscreen").hide();
            $("#messagescreen").show();
            $("#cartname").val("");
            closeCart();
            getCart();
            setTimeout("$(\"#messagescreen\").fadeOut()",2000);
            setTimeout("finish();",2500);
        }, 
        error: function(x,y,z) {
            var html = x.responseText; 
            $("#messageboxcontent").html("<img src=\"/images/1367442335_onebit_36.png\"><br><br>There was an error checking out.  Please try again!");
            $("#loadingscreen").hide();
            $("#messagescreen").show();
            getCart();
            setTimeout("$(\"#messagescreen\").fadeOut()",5000);
        }
    });
}

function finish() {
    //Check if something in the cart
    if ($("#carttabcount").html() == '0') {
        window.location='/';
    } else {
        if (confirm("Are you sure you want to end your session?  Any items in your shopping cart will be deleted!")) {
            deleteCartF(true);
        }
    }
}





/***** Edit Images *****/
function switchToCrop() {
    $("#switchToCrop").hide();
    $("#switchToAdjust").show();
    
    $("#editTitle").html("Crop");
    
    $("#cropImageBox").show();
    $("#adjustImageBox").hide();
    
    $("#image-container").hide();
    $("#crop-container").show();
    initCrop();
    setDefaultCropping();
}

function switchToAdjust() {
    $("#switchToCrop").show();
    $("#switchToAdjust").hide();
    
    $("#editTitle").html("Adjust");
    
    $("#cropImageBox").hide();
    $("#adjustImageBox").show();
    
    $("#image-container").show();
    $("#crop-container").hide();
}

 function initCrop(){
    $('#cropbox').Jcrop({
    aspectRatio: 7/5,
    onSelect: updateCoords,
    onChange: updateCoords
    },function(){
    jcrop_api = this;});
    
 } 
 
 function setDefaultCropping() {
    $("#selectCrop").val(croppingaspectratio); // set default ratio
    updateCropOptions();
}

function updateCoords(c)
{
    $('#x').val(c.x);
    $('#y').val(c.y);
    $('#w').val(c.w);
    $('#h').val(c.h);
};
function resetCoords()
{
    $('#x').val(0);
    $('#y').val(0);
    $('#w').val(0);
    $('#h').val(0);
}
function checkCoords()
{
    if (parseInt($('#w').val()) && $('#w').val()) {
        //alert(' x:'+$('#x').val()+' y:'+$('#y').val()+' w:'+$('#w').val()+' h:'+$('#h').val());
        cropImage();
    } else {
        alert('Please select a crop region then press save.');
    }

}
function getCroppingAspectRatio(imagewidth, imageheight){
    var cropratio = '5x7';
    if(imagewidth < imageheight){
        switch (cropratio) 
        {
            case '3x5': 
                cropratio = '5x3';
                break;
            case '4x6': 
                cropratio = '6x4';
                break;
            case '5x7': 
                cropratio = '7x5';
                break;
            case '6x8': 
                cropratio = '8x6';
                break;
            case '8x10': 
                cropratio = '10x8';
                break;
        }
    }
    return cropratio; 
}
function getStatus(value){
    var s = 0;
    switch (value) 
    {
        case '3x5': 
            s = 5/3;
            break;
        case '4x6': 
            s = 6/4;
            break;
        case '5x7': 
            s = 7/5;
            break;
        case '6x8': 
            s = 8/6;
            break;
        case '8x10': 
            s = 10/8;
            break;
        case '5x3':
            s = 3/5;
            break;
        case '6x4':
            s = 4/6;
            break;
        case '7x5':
            s = 5/7;
            break;
        case '8x6':
            s = 6/8;
            break;
        case '10x8':
            s = 8/10;
            break;
    }
    return s;
}
function updateCropOptions(){
    var value = $('#selectCrop').val();
    var ratio = getStatus(value);
    jcrop_api.setOptions(
    {
        aspectRatio: ratio
    });
    updateCoords;
}

function closeEditImage() {
    var code = $("#codevalue").html();
    var filepath = $("#filepath").html();
    window.location = "/search?search=" + code + "&view=" + encodeURIComponent(filepath);
}

function cropImage()
{
    var x = $('#x').val();
    var y = $('#y').val();
    var w = $('#w').val();
    var h = $('#h').val();
    var imagepath = $('#filepath').html();
    var code = $('#codevalue').html();
    var width = $('#cropbox').width();
    var height = $('#cropbox').height();
    window.location = "/crop/" + code + "?filepath=" + encodeURIComponent(imagepath) + "&x=" + x + "&y=" + y + "&w=" + w + "&h=" + h + "&width=" + width + "&height=" + height;

}


var toType = function(obj) {
  return ({}).toString.call(obj).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
}

function adjustImage_old() {
    var imagepath = $('#filepath').html();
    var code = $('#codevalue').html();

    applyAllFilters();
    var canvas = document.getElementById("image");
    var dataURL = canvas.toDataURL('image/jpeg',1);  

    // Get canvas data url
    var length = dataURL.length;  //console.log("dataURL length: "+length);
    var content = new Array();
    var limit = 5000000;   // max single post variable size 5mb
    var index = 0;
    var l;
    while (length > 0) {
        if (length <= limit)
            l = length;
        else
            l = limit;

        content.push(dataURL.substr(index * limit, l));
        length -= l;
        index++;
    }
    var datapart1 = content[0] ? content[0]:'';
    var datapart2 = content[1] ? content[1]:'';
    var datapart3 = content[2] ? content[2]:'';
    var datapart4 = content[3] ? content[3]:'';

    $.ajax({
        type: "POST",
        url: "/adjust/" + code,
        data: { 
            filepath: encodeURIComponent(imagepath),
            datalength: dataURL.length,
            datapart1: datapart1,
            datapart2: datapart2,
            datapart3: datapart3,
            datapart4: datapart4
        },
        success: function(json) {
            window.location = "/search?search=" + code + "&view=" + encodeURIComponent(imagepath);
        },
        error: function(x,y,z) {
            console.log('error');
        }
    });
    
}

function adjustImage() {
    
    applyAllFilters();
    var imagepath = $('#filepath').html();
    var code = $('#codevalue').html();
    var brightness = adjustbrightness;
    var contrast = adjustcontrast;
    //console.log("brightness: "+brightness+" contrast: "+contrast);
    window.location = "/adjust/" + code + "?filepath=" + encodeURIComponent(imagepath) + "&brightness=" + brightness + "&contrast=" + contrast;
    
}