/*!
 * jQuery UI 1.8.14
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI
 */ (function(c, j) {
    function k(a, b) {
        var d = a.nodeName.toLowerCase();
        if ("area" === d) {
            b = a.parentNode;
            d = b.name;
            if (!a.href || !d || b.nodeName.toLowerCase() !== "map") return false;
            a = c("img[usemap=#" + d + "]")[0];
            return !!a && l(a)
        }
        return (/input|select|textarea|button|object/.test(d) ? !a.disabled : "a" == d ? a.href || b : b) && l(a)
    }
    function l(a) {
        return !c(a).parents().andSelf().filter(function() {
            return c.curCSS(this, "visibility") === "hidden" || c.expr.filters.hidden(this)
        }).length
    }
    c.ui = c.ui || {};
    if (!c.ui.version) {
        c.extend(c.ui, {
            version: "1.8.14",
            keyCode: {
                ALT: 18,
                BACKSPACE: 8,
                CAPS_LOCK: 20,
                COMMA: 188,
                COMMAND: 91,
                COMMAND_LEFT: 91,
                COMMAND_RIGHT: 93,
                CONTROL: 17,
                DELETE: 46,
                DOWN: 40,
                END: 35,
                ENTER: 13,
                ESCAPE: 27,
                HOME: 36,
                INSERT: 45,
                LEFT: 37,
                MENU: 93,
                NUMPAD_ADD: 107,
                NUMPAD_DECIMAL: 110,
                NUMPAD_DIVIDE: 111,
                NUMPAD_ENTER: 108,
                NUMPAD_MULTIPLY: 106,
                NUMPAD_SUBTRACT: 109,
                PAGE_DOWN: 34,
                PAGE_UP: 33,
                PERIOD: 190,
                RIGHT: 39,
                SHIFT: 16,
                SPACE: 32,
                TAB: 9,
                UP: 38,
                WINDOWS: 91
            }
        });
        c.fn.extend({
            _focus: c.fn.focus,
            focus: function(a, b) {
                return typeof a === "number" ? this.each(function() {
                    var d = this;
                    setTimeout(function() {
                        c(d).focus();
                        b && b.call(d)
                    }, a)
                }) : this._focus.apply(this, arguments)
            },
            scrollParent: function() {
                var a;
                a = c.browser.msie && /(static|relative)/.test(this.css("position")) || /absolute/.test(this.css("position")) ? this.parents().filter(function() {
                    return /(relative|absolute|fixed)/.test(c.curCSS(this, "position", 1)) && /(auto|scroll)/.test(c.curCSS(this, "overflow", 1) + c.curCSS(this, "overflow-y", 1) + c.curCSS(this, "overflow-x", 1))
                }).eq(0) : this.parents().filter(function() {
                    return /(auto|scroll)/.test(c.curCSS(this, "overflow", 1) + c.curCSS(this, "overflow-y", 1) + c.curCSS(this, "overflow-x", 1))
                }).eq(0);
                return /fixed/.test(this.css("position")) || !a.length ? c(document) : a
            },
            zIndex: function(a) {
                if (a !== j) return this.css("zIndex", a);
                if (this.length) {
                    a = c(this[0]);
                    for (var b; a.length && a[0] !== document;) {
                        b = a.css("position");
                        if (b === "absolute" || b === "relative" || b === "fixed") {
                            b = parseInt(a.css("zIndex"), 10);
                            if (!isNaN(b) && b !== 0) return b
                        }
                        a = a.parent()
                    }
                }
                return 0
            },
            disableSelection: function() {
                return this.bind((c.support.selectstart ? "selectstart" : "mousedown") + ".ui-disableSelection", function(a) {
                    a.preventDefault()
                })
            },
            enableSelection: function() {
                return this.unbind(".ui-disableSelection")
            }
        });
        c.each(["Width", "Height"], function(a, b) {
            function d(f, g, m, n) {
                c.each(e, function() {
                    g -= parseFloat(c.curCSS(f, "padding" + this, true)) || 0;
                    if (m) g -= parseFloat(c.curCSS(f, "border" + this + "Width", true)) || 0;
                    if (n) g -= parseFloat(c.curCSS(f, "margin" + this, true)) || 0
                });
                return g
            }
            var e = b === "Width" ? ["Left", "Right"] : ["Top", "Bottom"],
                h = b.toLowerCase(),
                i = {
                    innerWidth: c.fn.innerWidth,
                    innerHeight: c.fn.innerHeight,
                    outerWidth: c.fn.outerWidth,
                    outerHeight: c.fn.outerHeight
                };
            c.fn["inner" + b] = function(f) {
                if (f === j) return i["inner" + b].call(this);
                return this.each(function() {
                    c(this).css(h, d(this, f) + "px")
                })
            };
            c.fn["outer" + b] = function(f, g) {
                if (typeof f !== "number") return i["outer" + b].call(this, f);
                return this.each(function() {
                    c(this).css(h, d(this, f, true, g) + "px")
                })
            }
        });
        c.extend(c.expr[":"], {
            data: function(a, b, d) {
                return !!c.data(a, d[3])
            },
            focusable: function(a) {
                return k(a, !isNaN(c.attr(a, "tabindex")))
            },
            tabbable: function(a) {
                var b = c.attr(a, "tabindex"),
                    d = isNaN(b);
                return (d || b >= 0) && k(a, !d)
            }
        });
        c(function() {
            var a = document.body,
                b = a.appendChild(b = document.createElement("div"));
            c.extend(b.style, {
                minHeight: "100px",
                height: "auto",
                padding: 0,
                borderWidth: 0
            });
            c.support.minHeight = b.offsetHeight === 100;
            c.support.selectstart = "onselectstart" in b;
            a.removeChild(b).style.display = "none"
        });
        c.extend(c.ui, {
            plugin: {
                add: function(a, b, d) {
                    a = c.ui[a].prototype;
                    for (var e in d) {
                        a.plugins[e] = a.plugins[e] || [];
                        a.plugins[e].push([b, d[e]])
                    }
                },
                call: function(a, b, d) {
                    if ((b = a.plugins[b]) && a.element[0].parentNode) for (var e = 0; e < b.length; e++) a.options[b[e][0]] && b[e][1].apply(a.element, d)
                }
            },
            contains: function(a, b) {
                return document.compareDocumentPosition ? a.compareDocumentPosition(b) & 16 : a !== b && a.contains(b)
            },
            hasScroll: function(a, b) {
                if (c(a).css("overflow") === "hidden") return false;
                b = b && b === "left" ? "scrollLeft" : "scrollTop";
                var d = false;
                if (a[b] > 0) return true;
                a[b] = 1;
                d = a[b] > 0;
                a[b] = 0;
                return d
            },
            isOverAxis: function(a, b, d) {
                return a > b && a < b + d
            },
            isOver: function(a, b, d, e, h, i) {
                return c.ui.isOverAxis(a, d, h) && c.ui.isOverAxis(b, e, i)
            }
        })
    }
})(jQuery);;
/*!
 * jQuery UI Widget 1.8.14
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Widget
 */ (function(b, j) {
    if (b.cleanData) {
        var k = b.cleanData;
        b.cleanData = function(a) {
            for (var c = 0, d;
            (d = a[c]) != null; c++) b(d).triggerHandler("remove");
            k(a)
        }
    } else {
        var l = b.fn.remove;
        b.fn.remove = function(a, c) {
            return this.each(function() {
                if (!c) if (!a || b.filter(a, [this]).length) b("*", this).add([this]).each(function() {
                    b(this).triggerHandler("remove")
                });
                return l.call(b(this), a, c)
            })
        }
    }
    b.widget = function(a, c, d) {
        var e = a.split(".")[0],
            f;
        a = a.split(".")[1];
        f = e + "-" + a;
        if (!d) {
            d = c;
            c = b.Widget
        }
        b.expr[":"][f] = function(h) {
            return !!b.data(h, a)
        };
        b[e] = b[e] || {};
        b[e][a] = function(h, g) {
            arguments.length && this._createWidget(h, g)
        };
        c = new c;
        c.options = b.extend(true, {}, c.options);
        b[e][a].prototype = b.extend(true, c, {
            namespace: e,
            widgetName: a,
            widgetEventPrefix: b[e][a].prototype.widgetEventPrefix || a,
            widgetBaseClass: f
        }, d);
        b.widget.bridge(a, b[e][a])
    };
    b.widget.bridge = function(a, c) {
        b.fn[a] = function(d) {
            var e = typeof d === "string",
                f = Array.prototype.slice.call(arguments, 1),
                h = this;
            d = !e && f.length ? b.extend.apply(null, [true, d].concat(f)) : d;
            if (e && d.charAt(0) === "_") return h;
            e ? this.each(function() {
                var g = b.data(this, a),
                    i = g && b.isFunction(g[d]) ? g[d].apply(g, f) : g;
                if (i !== g && i !== j) {
                    h = i;
                    return false
                }
            }) : this.each(function() {
                var g = b.data(this, a);
                g ? g.option(d || {})._init() : b.data(this, a, new c(d, this))
            });
            return h
        }
    };
    b.Widget = function(a, c) {
        arguments.length && this._createWidget(a, c)
    };
    b.Widget.prototype = {
        widgetName: "widget",
        widgetEventPrefix: "",
        options: {
            disabled: false
        },
        _createWidget: function(a, c) {
            b.data(c, this.widgetName, this);
            this.element = b(c);
            this.options = b.extend(true, {}, this.options, this._getCreateOptions(), a);
            var d = this;
            this.element.bind("remove." + this.widgetName, function() {
                d.destroy()
            });
            this._create();
            this._trigger("create");
            this._init()
        },
        _getCreateOptions: function() {
            return b.metadata && b.metadata.get(this.element[0])[this.widgetName]
        },
        _create: function() {},
        _init: function() {},
        destroy: function() {
            this.element.unbind("." + this.widgetName).removeData(this.widgetName);
            this.widget().unbind("." + this.widgetName).removeAttr("aria-disabled").removeClass(this.widgetBaseClass + "-disabled ui-state-disabled")
        },
        widget: function() {
            return this.element
        },
        option: function(a, c) {
            var d = a;
            if (arguments.length === 0) return b.extend({}, this.options);
            if (typeof a === "string") {
                if (c === j) return this.options[a];
                d = {};
                d[a] = c
            }
            this._setOptions(d);
            return this
        },
        _setOptions: function(a) {
            var c = this;
            b.each(a, function(d, e) {
                c._setOption(d, e)
            });
            return this
        },
        _setOption: function(a, c) {
            this.options[a] = c;
            if (a === "disabled") this.widget()[c ? "addClass" : "removeClass"](this.widgetBaseClass + "-disabled ui-state-disabled").attr("aria-disabled", c);
            return this
        },
        enable: function() {
            return this._setOption("disabled", false)
        },
        disable: function() {
            return this._setOption("disabled", true)
        },
        _trigger: function(a, c, d) {
            var e = this.options[a];
            c = b.Event(c);
            c.type = (a === this.widgetEventPrefix ? a : this.widgetEventPrefix + a).toLowerCase();
            d = d || {};
            if (c.originalEvent) {
                a = b.event.props.length;
                for (var f; a;) {
                    f = b.event.props[--a];
                    c[f] = c.originalEvent[f]
                }
            }
            this.element.trigger(c, d);
            return !(b.isFunction(e) && e.call(this.element[0], c, d) === false || c.isDefaultPrevented())
        }
    }
})(jQuery);;
/*!
 * jQuery UI Mouse 1.8.14
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Mouse
 *
 * Depends:
 *	jquery.ui.widget.js
 */ (function(b) {
    var d = false;
    b(document).mousedown(function() {
        d = false
    });
    b.widget("ui.mouse", {
        options: {
            cancel: ":input,option",
            distance: 1,
            delay: 0
        },
        _mouseInit: function() {
            var a = this;
            this.element.bind("mousedown." + this.widgetName, function(c) {
                return a._mouseDown(c)
            }).bind("click." + this.widgetName, function(c) {
                if (true === b.data(c.target, a.widgetName + ".preventClickEvent")) {
                    b.removeData(c.target, a.widgetName + ".preventClickEvent");
                    c.stopImmediatePropagation();
                    return false
                }
            });
            this.started = false
        },
        _mouseDestroy: function() {
            this.element.unbind("." + this.widgetName)
        },
        _mouseDown: function(a) {
            if (!d) {
                this._mouseStarted && this._mouseUp(a);
                this._mouseDownEvent = a;
                var c = this,
                    f = a.which == 1,
                    g = typeof this.options.cancel == "string" ? b(a.target).closest(this.options.cancel).length : false;
                if (!f || g || !this._mouseCapture(a)) return true;
                this.mouseDelayMet = !this.options.delay;
                if (!this.mouseDelayMet) this._mouseDelayTimer = setTimeout(function() {
                    c.mouseDelayMet = true
                }, this.options.delay);
                if (this._mouseDistanceMet(a) && this._mouseDelayMet(a)) {
                    this._mouseStarted = this._mouseStart(a) !== false;
                    if (!this._mouseStarted) {
                        a.preventDefault();
                        return true
                    }
                }
                true === b.data(a.target, this.widgetName + ".preventClickEvent") && b.removeData(a.target, this.widgetName + ".preventClickEvent");
                this._mouseMoveDelegate = function(e) {
                    return c._mouseMove(e)
                };
                this._mouseUpDelegate = function(e) {
                    return c._mouseUp(e)
                };
                b(document).bind("mousemove." + this.widgetName, this._mouseMoveDelegate).bind("mouseup." + this.widgetName, this._mouseUpDelegate);
                a.preventDefault();
                return d = true
            }
        },
        _mouseMove: function(a) {
            if (b.browser.msie && !(document.documentMode >= 9) && !a.button) return this._mouseUp(a);
            if (this._mouseStarted) {
                this._mouseDrag(a);
                return a.preventDefault()
            }
            if (this._mouseDistanceMet(a) && this._mouseDelayMet(a))(this._mouseStarted = this._mouseStart(this._mouseDownEvent, a) !== false) ? this._mouseDrag(a) : this._mouseUp(a);
            return !this._mouseStarted
        },
        _mouseUp: function(a) {
            b(document).unbind("mousemove." + this.widgetName, this._mouseMoveDelegate).unbind("mouseup." + this.widgetName, this._mouseUpDelegate);
            if (this._mouseStarted) {
                this._mouseStarted = false;
                a.target == this._mouseDownEvent.target && b.data(a.target, this.widgetName + ".preventClickEvent", true);
                this._mouseStop(a)
            }
            return false
        },
        _mouseDistanceMet: function(a) {
            return Math.max(Math.abs(this._mouseDownEvent.pageX - a.pageX), Math.abs(this._mouseDownEvent.pageY - a.pageY)) >= this.options.distance
        },
        _mouseDelayMet: function() {
            return this.mouseDelayMet
        },
        _mouseStart: function() {},
        _mouseDrag: function() {},
        _mouseStop: function() {},
        _mouseCapture: function() {
            return true
        }
    })
})(jQuery);;
/*
 * jQuery UI Position 1.8.14
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Position
 */ (function(c) {
    c.ui = c.ui || {};
    var n = /left|center|right/,
        o = /top|center|bottom/,
        t = c.fn.position,
        u = c.fn.offset;
    c.fn.position = function(b) {
        if (!b || !b.of) return t.apply(this, arguments);
        b = c.extend({}, b);
        var a = c(b.of),
            d = a[0],
            g = (b.collision || "flip").split(" "),
            e = b.offset ? b.offset.split(" ") : [0, 0],
            h, k, j;
        if (d.nodeType === 9) {
            h = a.width();
            k = a.height();
            j = {
                top: 0,
                left: 0
            }
        } else if (d.setTimeout) {
            h = a.width();
            k = a.height();
            j = {
                top: a.scrollTop(),
                left: a.scrollLeft()
            }
        } else if (d.preventDefault) {
            b.at = "left top";
            h = k = 0;
            j = {
                top: b.of.pageY,
                left: b.of.pageX
            }
        } else {
            h = a.outerWidth();
            k = a.outerHeight();
            j = a.offset()
        }
        c.each(["my", "at"], function() {
            var f = (b[this] || "").split(" ");
            if (f.length === 1) f = n.test(f[0]) ? f.concat(["center"]) : o.test(f[0]) ? ["center"].concat(f) : ["center", "center"];
            f[0] = n.test(f[0]) ? f[0] : "center";
            f[1] = o.test(f[1]) ? f[1] : "center";
            b[this] = f
        });
        if (g.length === 1) g[1] = g[0];
        e[0] = parseInt(e[0], 10) || 0;
        if (e.length === 1) e[1] = e[0];
        e[1] = parseInt(e[1], 10) || 0;
        if (b.at[0] === "right") j.left += h;
        else if (b.at[0] === "center") j.left += h / 2;
        if (b.at[1] === "bottom") j.top += k;
        else if (b.at[1] === "center") j.top += k / 2;
        j.left += e[0];
        j.top += e[1];
        return this.each(function() {
            var f = c(this),
                l = f.outerWidth(),
                m = f.outerHeight(),
                p = parseInt(c.curCSS(this, "marginLeft", true)) || 0,
                q = parseInt(c.curCSS(this, "marginTop", true)) || 0,
                v = l + p + (parseInt(c.curCSS(this, "marginRight", true)) || 0),
                w = m + q + (parseInt(c.curCSS(this, "marginBottom", true)) || 0),
                i = c.extend({}, j),
                r;
            if (b.my[0] === "right") i.left -= l;
            else if (b.my[0] === "center") i.left -= l / 2;
            if (b.my[1] === "bottom") i.top -= m;
            else if (b.my[1] === "center") i.top -= m / 2;
            i.left = Math.round(i.left);
            i.top = Math.round(i.top);
            r = {
                left: i.left - p,
                top: i.top - q
            };
            c.each(["left", "top"], function(s, x) {
                c.ui.position[g[s]] && c.ui.position[g[s]][x](i, {
                    targetWidth: h,
                    targetHeight: k,
                    elemWidth: l,
                    elemHeight: m,
                    collisionPosition: r,
                    collisionWidth: v,
                    collisionHeight: w,
                    offset: e,
                    my: b.my,
                    at: b.at
                })
            });
            c.fn.bgiframe && f.bgiframe();
            f.offset(c.extend(i, {
                using: b.using
            }))
        })
    };
    c.ui.position = {
        fit: {
            left: function(b, a) {
                var d = c(window);
                d = a.collisionPosition.left + a.collisionWidth - d.width() - d.scrollLeft();
                b.left = d > 0 ? b.left - d : Math.max(b.left - a.collisionPosition.left, b.left)
            },
            top: function(b, a) {
                var d = c(window);
                d = a.collisionPosition.top + a.collisionHeight - d.height() - d.scrollTop();
                b.top = d > 0 ? b.top - d : Math.max(b.top - a.collisionPosition.top, b.top)
            }
        },
        flip: {
            left: function(b, a) {
                if (a.at[0] !== "center") {
                    var d = c(window);
                    d = a.collisionPosition.left + a.collisionWidth - d.width() - d.scrollLeft();
                    var g = a.my[0] === "left" ? -a.elemWidth : a.my[0] === "right" ? a.elemWidth : 0,
                        e = a.at[0] === "left" ? a.targetWidth : -a.targetWidth,
                        h = -2 * a.offset[0];
                    b.left += a.collisionPosition.left < 0 ? g + e + h : d > 0 ? g + e + h : 0
                }
            },
            top: function(b, a) {
                if (a.at[1] !== "center") {
                    var d = c(window);
                    d = a.collisionPosition.top + a.collisionHeight - d.height() - d.scrollTop();
                    var g = a.my[1] === "top" ? -a.elemHeight : a.my[1] === "bottom" ? a.elemHeight : 0,
                        e = a.at[1] === "top" ? a.targetHeight : -a.targetHeight,
                        h = -2 * a.offset[1];
                    b.top += a.collisionPosition.top < 0 ? g + e + h : d > 0 ? g + e + h : 0
                }
            }
        }
    };
    if (!c.offset.setOffset) {
        c.offset.setOffset = function(b, a) {
            if (/static/.test(c.curCSS(b, "position"))) b.style.position = "relative";
            var d = c(b),
                g = d.offset(),
                e = parseInt(c.curCSS(b, "top", true), 10) || 0,
                h = parseInt(c.curCSS(b, "left", true), 10) || 0;
            g = {
                top: a.top - g.top + e,
                left: a.left - g.left + h
            };
            "using" in a ? a.using.call(b, g) : d.css(g)
        };
        c.fn.offset = function(b) {
            var a = this[0];
            if (!a || !a.ownerDocument) return null;
            if (b) return this.each(function() {
                c.offset.setOffset(this, b)
            });
            return u.call(this)
        }
    }
})(jQuery);;
/*
 * jQuery UI Slider 1.8.14
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Slider
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */ (function(d) {
    d.widget("ui.slider", d.ui.mouse, {
        widgetEventPrefix: "slide",
        options: {
            animate: false,
            distance: 0,
            max: 100,
            min: 0,
            orientation: "horizontal",
            range: false,
            step: 1,
            value: 0,
            values: null
        },
        _create: function() {
            var b = this,
                a = this.options,
                c = this.element.find(".ui-slider-handle").addClass("ui-state-default ui-corner-all"),
                f = a.values && a.values.length || 1,
                e = [];
            this._mouseSliding = this._keySliding = false;
            this._animateOff = true;
            this._handleIndex = null;
            this._detectOrientation();
            this._mouseInit();
            this.element.addClass("ui-slider ui-slider-" + this.orientation + " ui-widget ui-widget-content ui-corner-all" + (a.disabled ? " ui-slider-disabled ui-disabled" : ""));
            this.range = d([]);
            if (a.range) {
                if (a.range === true) {
                    if (!a.values) a.values = [this._valueMin(), this._valueMin()];
                    if (a.values.length && a.values.length !== 2) a.values = [a.values[0], a.values[0]]
                }
                this.range = d("<div></div>").appendTo(this.element).addClass("ui-slider-range ui-widget-header" + (a.range === "min" || a.range === "max" ? " ui-slider-range-" + a.range : ""))
            }
            for (var j = c.length; j < f; j += 1) e.push("<a class='ui-slider-handle ui-state-default ui-corner-all' href='#'></a>");
            this.handles = c.add(d(e.join("")).appendTo(b.element));
            this.handle = this.handles.eq(0);
            this.handles.add(this.range).filter("a").click(function(g) {
                g.preventDefault()
            }).hover(function() {
                a.disabled || d(this).addClass("ui-state-hover")
            }, function() {
                d(this).removeClass("ui-state-hover")
            }).focus(function() {
                if (a.disabled) d(this).blur();
                else {
                    d(".ui-slider .ui-state-focus").removeClass("ui-state-focus");
                    d(this).addClass("ui-state-focus")
                }
            }).blur(function() {
                d(this).removeClass("ui-state-focus")
            });
            this.handles.each(function(g) {
                d(this).data("index.ui-slider-handle", g)
            });
            this.handles.keydown(function(g) {
                var k = true,
                    l = d(this).data("index.ui-slider-handle"),
                    i, h, m;
                if (!b.options.disabled) {
                    switch (g.keyCode) {
                    case d.ui.keyCode.HOME:
                    case d.ui.keyCode.END:
                    case d.ui.keyCode.PAGE_UP:
                    case d.ui.keyCode.PAGE_DOWN:
                    case d.ui.keyCode.UP:
                    case d.ui.keyCode.RIGHT:
                    case d.ui.keyCode.DOWN:
                    case d.ui.keyCode.LEFT:
                        k = false;
                        if (!b._keySliding) {
                            b._keySliding = true;
                            d(this).addClass("ui-state-active");
                            i = b._start(g, l);
                            if (i === false) return
                        }
                        break
                    }
                    m = b.options.step;
                    i = b.options.values && b.options.values.length ? (h = b.values(l)) : (h = b.value());
                    switch (g.keyCode) {
                    case d.ui.keyCode.HOME:
                        h = b._valueMin();
                        break;
                    case d.ui.keyCode.END:
                        h = b._valueMax();
                        break;
                    case d.ui.keyCode.PAGE_UP:
                        h = b._trimAlignValue(i + (b._valueMax() - b._valueMin()) / 5);
                        break;
                    case d.ui.keyCode.PAGE_DOWN:
                        h = b._trimAlignValue(i - (b._valueMax() - b._valueMin()) / 5);
                        break;
                    case d.ui.keyCode.UP:
                    case d.ui.keyCode.RIGHT:
                        if (i === b._valueMax()) return;
                        h = b._trimAlignValue(i + m);
                        break;
                    case d.ui.keyCode.DOWN:
                    case d.ui.keyCode.LEFT:
                        if (i === b._valueMin()) return;
                        h = b._trimAlignValue(i - m);
                        break
                    }
                    b._slide(g, l, h);
                    return k
                }
            }).keyup(function(g) {
                var k = d(this).data("index.ui-slider-handle");
                if (b._keySliding) {
                    b._keySliding = false;
                    b._stop(g, k);
                    b._change(g, k);
                    d(this).removeClass("ui-state-active")
                }
            });
            this._refreshValue();
            this._animateOff = false
        },
        destroy: function() {
            this.handles.remove();
            this.range.remove();
            this.element.removeClass("ui-slider ui-slider-horizontal ui-slider-vertical ui-slider-disabled ui-widget ui-widget-content ui-corner-all").removeData("slider").unbind(".slider");
            this._mouseDestroy();
            return this
        },
        _mouseCapture: function(b) {
            var a = this.options,
                c, f, e, j, g;
            if (a.disabled) return false;
            this.elementSize = {
                width: this.element.outerWidth(),
                height: this.element.outerHeight()
            };
            this.elementOffset = this.element.offset();
            c = this._normValueFromMouse({
                x: b.pageX,
                y: b.pageY
            });
            f = this._valueMax() - this._valueMin() + 1;
            j = this;
            this.handles.each(function(k) {
                var l = Math.abs(c - j.values(k));
                if (f > l) {
                    f = l;
                    e = d(this);
                    g = k
                }
            });
            if (a.range === true && this.values(1) === a.min) {
                g += 1;
                e = d(this.handles[g])
            }
            if (this._start(b, g) === false) return false;
            this._mouseSliding = true;
            j._handleIndex = g;
            e.addClass("ui-state-active").focus();
            a = e.offset();
            this._clickOffset = !d(b.target).parents().andSelf().is(".ui-slider-handle") ? {
                left: 0,
                top: 0
            } : {
                left: b.pageX - a.left - e.width() / 2,
                top: b.pageY - a.top - e.height() / 2 - (parseInt(e.css("borderTopWidth"), 10) || 0) - (parseInt(e.css("borderBottomWidth"), 10) || 0) + (parseInt(e.css("marginTop"), 10) || 0)
            };
            this.handles.hasClass("ui-state-hover") || this._slide(b, g, c);
            return this._animateOff = true
        },
        _mouseStart: function() {
            return true
        },
        _mouseDrag: function(b) {
            var a = this._normValueFromMouse({
                x: b.pageX,
                y: b.pageY
            });
            this._slide(b, this._handleIndex, a);
            return false
        },
        _mouseStop: function(b) {
            this.handles.removeClass("ui-state-active");
            this._mouseSliding = false;
            this._stop(b, this._handleIndex);
            this._change(b, this._handleIndex);
            this._clickOffset = this._handleIndex = null;
            return this._animateOff = false
        },
        _detectOrientation: function() {
            this.orientation = this.options.orientation === "vertical" ? "vertical" : "horizontal"
        },
        _normValueFromMouse: function(b) {
            var a;
            if (this.orientation === "horizontal") {
                a = this.elementSize.width;
                b = b.x - this.elementOffset.left - (this._clickOffset ? this._clickOffset.left : 0)
            } else {
                a = this.elementSize.height;
                b = b.y - this.elementOffset.top - (this._clickOffset ? this._clickOffset.top : 0)
            }
            a = b / a;
            if (a > 1) a = 1;
            if (a < 0) a = 0;
            if (this.orientation === "vertical") a = 1 - a;
            b = this._valueMax() - this._valueMin();
            return this._trimAlignValue(this._valueMin() + a * b)
        },
        _start: function(b, a) {
            var c = {
                handle: this.handles[a],
                value: this.value()
            };
            if (this.options.values && this.options.values.length) {
                c.value = this.values(a);
                c.values = this.values()
            }
            return this._trigger("start", b, c)
        },
        _slide: function(b, a, c) {
            var f;
            if (this.options.values && this.options.values.length) {
                f = this.values(a ? 0 : 1);
                if (this.options.values.length === 2 && this.options.range === true && (a === 0 && c > f || a === 1 && c < f)) c = f;
                if (c !== this.values(a)) {
                    f = this.values();
                    f[a] = c;
                    b = this._trigger("slide", b, {
                        handle: this.handles[a],
                        value: c,
                        values: f
                    });
                    this.values(a ? 0 : 1);
                    b !== false && this.values(a, c, true)
                }
            } else if (c !== this.value()) {
                b = this._trigger("slide", b, {
                    handle: this.handles[a],
                    value: c
                });
                b !== false && this.value(c)
            }
        },
        _stop: function(b, a) {
            var c = {
                handle: this.handles[a],
                value: this.value()
            };
            if (this.options.values && this.options.values.length) {
                c.value = this.values(a);
                c.values = this.values()
            }
            this._trigger("stop", b, c)
        },
        _change: function(b, a) {
            if (!this._keySliding && !this._mouseSliding) {
                var c = {
                    handle: this.handles[a],
                    value: this.value()
                };
                if (this.options.values && this.options.values.length) {
                    c.value = this.values(a);
                    c.values = this.values()
                }
                this._trigger("change", b, c)
            }
        },
        value: function(b) {
            if (arguments.length) {
                this.options.value = this._trimAlignValue(b);
                this._refreshValue();
                this._change(null, 0)
            } else return this._value()
        },
        values: function(b, a) {
            var c, f, e;
            if (arguments.length > 1) {
                this.options.values[b] = this._trimAlignValue(a);
                this._refreshValue();
                this._change(null, b)
            } else if (arguments.length) if (d.isArray(arguments[0])) {
                c = this.options.values;
                f = arguments[0];
                for (e = 0; e < c.length; e += 1) {
                    c[e] = this._trimAlignValue(f[e]);
                    this._change(null, e)
                }
                this._refreshValue()
            } else return this.options.values && this.options.values.length ? this._values(b) : this.value();
            else return this._values()
        },
        _setOption: function(b, a) {
            var c, f = 0;
            if (d.isArray(this.options.values)) f = this.options.values.length;
            d.Widget.prototype._setOption.apply(this, arguments);
            switch (b) {
            case "disabled":
                if (a) {
                    this.handles.filter(".ui-state-focus").blur();
                    this.handles.removeClass("ui-state-hover");
                    this.handles.attr("disabled", "disabled");
                    this.element.addClass("ui-disabled")
                } else {
                    this.handles.removeAttr("disabled");
                    this.element.removeClass("ui-disabled")
                }
                break;
            case "orientation":
                this._detectOrientation();
                this.element.removeClass("ui-slider-horizontal ui-slider-vertical").addClass("ui-slider-" + this.orientation);
                this._refreshValue();
                break;
            case "value":
                this._animateOff = true;
                this._refreshValue();
                this._change(null, 0);
                this._animateOff = false;
                break;
            case "values":
                this._animateOff = true;
                this._refreshValue();
                for (c = 0; c < f; c += 1) this._change(null, c);
                this._animateOff = false;
                break
            }
        },
        _value: function() {
            var b = this.options.value;
            return b = this._trimAlignValue(b)
        },
        _values: function(b) {
            var a, c;
            if (arguments.length) {
                a = this.options.values[b];
                return a = this._trimAlignValue(a)
            } else {
                a = this.options.values.slice();
                for (c = 0; c < a.length; c += 1) a[c] = this._trimAlignValue(a[c]);
                return a
            }
        },
        _trimAlignValue: function(b) {
            if (b <= this._valueMin()) return this._valueMin();
            if (b >= this._valueMax()) return this._valueMax();
            var a = this.options.step > 0 ? this.options.step : 1,
                c = (b - this._valueMin()) % a;
            alignValue = b - c;
            if (Math.abs(c) * 2 >= a) alignValue += c > 0 ? a : -a;
            return parseFloat(alignValue.toFixed(5))
        },
        _valueMin: function() {
            return this.options.min
        },
        _valueMax: function() {
            return this.options.max
        },
        _refreshValue: function() {
            var b = this.options.range,
                a = this.options,
                c = this,
                f = !this._animateOff ? a.animate : false,
                e, j = {},
                g, k, l, i;
            if (this.options.values && this.options.values.length) this.handles.each(function(h) {
                e = (c.values(h) - c._valueMin()) / (c._valueMax() - c._valueMin()) * 100;
                j[c.orientation === "horizontal" ? "left" : "bottom"] = e + "%";
                d(this).stop(1, 1)[f ? "animate" : "css"](j, a.animate);
                if (c.options.range === true) if (c.orientation === "horizontal") {
                    if (h === 0) c.range.stop(1, 1)[f ? "animate" : "css"]({
                        left: e + "%"
                    }, a.animate);
                    if (h === 1) c.range[f ? "animate" : "css"]({
                        width: e - g + "%"
                    }, {
                        queue: false,
                        duration: a.animate
                    })
                } else {
                    if (h === 0) c.range.stop(1, 1)[f ? "animate" : "css"]({
                        bottom: e + "%"
                    }, a.animate);
                    if (h === 1) c.range[f ? "animate" : "css"]({
                        height: e - g + "%"
                    }, {
                        queue: false,
                        duration: a.animate
                    })
                }
                g = e
            });
            else {
                k = this.value();
                l = this._valueMin();
                i = this._valueMax();
                e = i !== l ? (k - l) / (i - l) * 100 : 0;
                j[c.orientation === "horizontal" ? "left" : "bottom"] = e + "%";
                this.handle.stop(1, 1)[f ? "animate" : "css"](j, a.animate);
                if (b === "min" && this.orientation === "horizontal") this.range.stop(1, 1)[f ? "animate" : "css"]({
                    width: e + "%"
                }, a.animate);
                if (b === "max" && this.orientation === "horizontal") this.range[f ? "animate" : "css"]({
                    width: 100 - e + "%"
                }, {
                    queue: false,
                    duration: a.animate
                });
                if (b === "min" && this.orientation === "vertical") this.range.stop(1, 1)[f ? "animate" : "css"]({
                    height: e + "%"
                }, a.animate);
                if (b === "max" && this.orientation === "vertical") this.range[f ? "animate" : "css"]({
                    height: 100 - e + "%"
                }, {
                    queue: false,
                    duration: a.animate
                })
            }
        }
    });
    d.extend(d.ui.slider, {
        version: "1.8.14"
    })
})(jQuery);;
/*
 * jQuery UI Effects 1.8.14
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/
 */
jQuery.effects ||
function(f, j) {
    function m(c) {
        var a;
        if (c && c.constructor == Array && c.length == 3) return c;
        if (a = /rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/.exec(c)) return [parseInt(a[1], 10), parseInt(a[2], 10), parseInt(a[3], 10)];
        if (a = /rgb\(\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*\)/.exec(c)) return [parseFloat(a[1]) * 2.55, parseFloat(a[2]) * 2.55, parseFloat(a[3]) * 2.55];
        if (a = /#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})/.exec(c)) return [parseInt(a[1], 16), parseInt(a[2], 16), parseInt(a[3], 16)];
        if (a = /#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])/.exec(c)) return [parseInt(a[1] + a[1], 16), parseInt(a[2] + a[2], 16), parseInt(a[3] + a[3], 16)];
        if (/rgba\(0, 0, 0, 0\)/.exec(c)) return n.transparent;
        return n[f.trim(c).toLowerCase()]
    }
    function s(c, a) {
        var b;
        do {
            b = f.curCSS(c, a);
            if (b != "" && b != "transparent" || f.nodeName(c, "body")) break;
            a = "backgroundColor"
        } while (c = c.parentNode);
        return m(b)
    }
    function o() {
        var c = document.defaultView ? document.defaultView.getComputedStyle(this, null) : this.currentStyle,
            a = {},
            b, d;
        if (c && c.length && c[0] && c[c[0]]) for (var e = c.length; e--;) {
            b = c[e];
            if (typeof c[b] == "string") {
                d = b.replace(/\-(\w)/g, function(g, h) {
                    return h.toUpperCase()
                });
                a[d] = c[b]
            }
        } else for (b in c) if (typeof c[b] === "string") a[b] = c[b];
        return a
    }
    function p(c) {
        var a, b;
        for (a in c) {
            b = c[a];
            if (b == null || f.isFunction(b) || a in t || /scrollbar/.test(a) || !/color/i.test(a) && isNaN(parseFloat(b))) delete c[a]
        }
        return c
    }
    function u(c, a) {
        var b = {
            _: 0
        },
            d;
        for (d in a) if (c[d] != a[d]) b[d] = a[d];
        return b
    }
    function k(c, a, b, d) {
        if (typeof c == "object") {
            d = a;
            b = null;
            a = c;
            c = a.effect
        }
        if (f.isFunction(a)) {
            d = a;
            b = null;
            a = {}
        }
        if (typeof a == "number" || f.fx.speeds[a]) {
            d = b;
            b = a;
            a = {}
        }
        if (f.isFunction(b)) {
            d = b;
            b = null
        }
        a = a || {};
        b = b || a.duration;
        b = f.fx.off ? 0 : typeof b == "number" ? b : b in f.fx.speeds ? f.fx.speeds[b] : f.fx.speeds._default;
        d = d || a.complete;
        return [c, a, b, d]
    }
    function l(c) {
        if (!c || typeof c === "number" || f.fx.speeds[c]) return true;
        if (typeof c === "string" && !f.effects[c]) return true;
        return false
    }
    f.effects = {};
    f.each(["backgroundColor", "borderBottomColor", "borderLeftColor", "borderRightColor", "borderTopColor", "borderColor", "color", "outlineColor"], function(c, a) {
        f.fx.step[a] = function(b) {
            if (!b.colorInit) {
                b.start = s(b.elem, a);
                b.end = m(b.end);
                b.colorInit = true
            }
            b.elem.style[a] = "rgb(" + Math.max(Math.min(parseInt(b.pos * (b.end[0] - b.start[0]) + b.start[0], 10), 255), 0) + "," + Math.max(Math.min(parseInt(b.pos * (b.end[1] - b.start[1]) + b.start[1], 10), 255), 0) + "," + Math.max(Math.min(parseInt(b.pos * (b.end[2] - b.start[2]) + b.start[2], 10), 255), 0) + ")"
        }
    });
    var n = {
        aqua: [0, 255, 255],
        azure: [240, 255, 255],
        beige: [245, 245, 220],
        black: [0, 0, 0],
        blue: [0, 0, 255],
        brown: [165, 42, 42],
        cyan: [0, 255, 255],
        darkblue: [0, 0, 139],
        darkcyan: [0, 139, 139],
        darkgrey: [169, 169, 169],
        darkgreen: [0, 100, 0],
        darkkhaki: [189, 183, 107],
        darkmagenta: [139, 0, 139],
        darkolivegreen: [85, 107, 47],
        darkorange: [255, 140, 0],
        darkorchid: [153, 50, 204],
        darkred: [139, 0, 0],
        darksalmon: [233, 150, 122],
        darkviolet: [148, 0, 211],
        fuchsia: [255, 0, 255],
        gold: [255, 215, 0],
        green: [0, 128, 0],
        indigo: [75, 0, 130],
        khaki: [240, 230, 140],
        lightblue: [173, 216, 230],
        lightcyan: [224, 255, 255],
        lightgreen: [144, 238, 144],
        lightgrey: [211, 211, 211],
        lightpink: [255, 182, 193],
        lightyellow: [255, 255, 224],
        lime: [0, 255, 0],
        magenta: [255, 0, 255],
        maroon: [128, 0, 0],
        navy: [0, 0, 128],
        olive: [128, 128, 0],
        orange: [255, 165, 0],
        pink: [255, 192, 203],
        purple: [128, 0, 128],
        violet: [128, 0, 128],
        red: [255, 0, 0],
        silver: [192, 192, 192],
        white: [255, 255, 255],
        yellow: [255, 255, 0],
        transparent: [255, 255, 255]
    },
        q = ["add", "remove", "toggle"],
        t = {
            border: 1,
            borderBottom: 1,
            borderColor: 1,
            borderLeft: 1,
            borderRight: 1,
            borderTop: 1,
            borderWidth: 1,
            margin: 1,
            padding: 1
        };
    f.effects.animateClass = function(c, a, b, d) {
        if (f.isFunction(b)) {
            d = b;
            b = null
        }
        return this.queue(function() {
            var e = f(this),
                g = e.attr("style") || " ",
                h = p(o.call(this)),
                r, v = e.attr("class");
            f.each(q, function(w, i) {
                c[i] && e[i + "Class"](c[i])
            });
            r = p(o.call(this));
            e.attr("class", v);
            e.animate(u(h, r), {
                queue: false,
                duration: a,
                easing: b,
                complete: function() {
                    f.each(q, function(w, i) {
                        c[i] && e[i + "Class"](c[i])
                    });
                    if (typeof e.attr("style") == "object") {
                        e.attr("style").cssText = "";
                        e.attr("style").cssText = g
                    } else e.attr("style", g);
                    d && d.apply(this, arguments);
                    f.dequeue(this)
                }
            })
        })
    };
    f.fn.extend({
        _addClass: f.fn.addClass,
        addClass: function(c, a, b, d) {
            return a ? f.effects.animateClass.apply(this, [{
                add: c
            },
            a, b, d]) : this._addClass(c)
        },
        _removeClass: f.fn.removeClass,
        removeClass: function(c, a, b, d) {
            return a ? f.effects.animateClass.apply(this, [{
                remove: c
            },
            a, b, d]) : this._removeClass(c)
        },
        _toggleClass: f.fn.toggleClass,
        toggleClass: function(c, a, b, d, e) {
            return typeof a == "boolean" || a === j ? b ? f.effects.animateClass.apply(this, [a ? {
                add: c
            } : {
                remove: c
            },
            b, d, e]) : this._toggleClass(c, a) : f.effects.animateClass.apply(this, [{
                toggle: c
            },
            a, b, d])
        },
        switchClass: function(c, a, b, d, e) {
            return f.effects.animateClass.apply(this, [{
                add: a,
                remove: c
            },
            b, d, e])
        }
    });
    f.extend(f.effects, {
        version: "1.8.14",
        save: function(c, a) {
            for (var b = 0; b < a.length; b++) a[b] !== null && c.data("ec.storage." + a[b], c[0].style[a[b]])
        },
        restore: function(c, a) {
            for (var b = 0; b < a.length; b++) a[b] !== null && c.css(a[b], c.data("ec.storage." + a[b]))
        },
        setMode: function(c, a) {
            if (a == "toggle") a = c.is(":hidden") ? "show" : "hide";
            return a
        },
        getBaseline: function(c, a) {
            var b;
            switch (c[0]) {
            case "top":
                b = 0;
                break;
            case "middle":
                b = 0.5;
                break;
            case "bottom":
                b = 1;
                break;
            default:
                b = c[0] / a.height
            }
            switch (c[1]) {
            case "left":
                c = 0;
                break;
            case "center":
                c = 0.5;
                break;
            case "right":
                c = 1;
                break;
            default:
                c = c[1] / a.width
            }
            return {
                x: c,
                y: b
            }
        },
        createWrapper: function(c) {
            if (c.parent().is(".ui-effects-wrapper")) return c.parent();
            var a = {
                width: c.outerWidth(true),
                height: c.outerHeight(true),
                "float": c.css("float")
            },
                b = f("<div></div>").addClass("ui-effects-wrapper").css({
                    fontSize: "100%",
                    background: "transparent",
                    border: "none",
                    margin: 0,
                    padding: 0
                });
            c.wrap(b);
            b = c.parent();
            if (c.css("position") == "static") {
                b.css({
                    position: "relative"
                });
                c.css({
                    position: "relative"
                })
            } else {
                f.extend(a, {
                    position: c.css("position"),
                    zIndex: c.css("z-index")
                });
                f.each(["top", "left", "bottom", "right"], function(d, e) {
                    a[e] = c.css(e);
                    if (isNaN(parseInt(a[e], 10))) a[e] = "auto"
                });
                c.css({
                    position: "relative",
                    top: 0,
                    left: 0,
                    right: "auto",
                    bottom: "auto"
                })
            }
            return b.css(a).show()
        },
        removeWrapper: function(c) {
            if (c.parent().is(".ui-effects-wrapper")) return c.parent().replaceWith(c);
            return c
        },
        setTransition: function(c, a, b, d) {
            d = d || {};
            f.each(a, function(e, g) {
                unit = c.cssUnit(g);
                if (unit[0] > 0) d[g] = unit[0] * b + unit[1]
            });
            return d
        }
    });
    f.fn.extend({
        effect: function(c) {
            var a = k.apply(this, arguments),
                b = {
                    options: a[1],
                    duration: a[2],
                    callback: a[3]
                };
            a = b.options.mode;
            var d = f.effects[c];
            if (f.fx.off || !d) return a ? this[a](b.duration, b.callback) : this.each(function() {
                b.callback && b.callback.call(this)
            });
            return d.call(this, b)
        },
        _show: f.fn.show,
        show: function(c) {
            if (l(c)) return this._show.apply(this, arguments);
            else {
                var a = k.apply(this, arguments);
                a[1].mode = "show";
                return this.effect.apply(this, a)
            }
        },
        _hide: f.fn.hide,
        hide: function(c) {
            if (l(c)) return this._hide.apply(this, arguments);
            else {
                var a = k.apply(this, arguments);
                a[1].mode = "hide";
                return this.effect.apply(this, a)
            }
        },
        __toggle: f.fn.toggle,
        toggle: function(c) {
            if (l(c) || typeof c === "boolean" || f.isFunction(c)) return this.__toggle.apply(this, arguments);
            else {
                var a = k.apply(this, arguments);
                a[1].mode = "toggle";
                return this.effect.apply(this, a)
            }
        },
        cssUnit: function(c) {
            var a = this.css(c),
                b = [];
            f.each(["em", "px", "%", "pt"], function(d, e) {
                if (a.indexOf(e) > 0) b = [parseFloat(a), e]
            });
            return b
        }
    });
    f.easing.jswing = f.easing.swing;
    f.extend(f.easing, {
        def: "easeOutQuad",
        swing: function(c, a, b, d, e) {
            return f.easing[f.easing.def](c, a, b, d, e)
        },
        easeInQuad: function(c, a, b, d, e) {
            return d * (a /= e) * a + b
        },
        easeOutQuad: function(c, a, b, d, e) {
            return -d * (a /= e) * (a - 2) + b
        },
        easeInOutQuad: function(c, a, b, d, e) {
            if ((a /= e / 2) < 1) return d / 2 * a * a + b;
            return -d / 2 * (--a * (a - 2) - 1) + b
        },
        easeInCubic: function(c, a, b, d, e) {
            return d * (a /= e) * a * a + b
        },
        easeOutCubic: function(c, a, b, d, e) {
            return d * ((a = a / e - 1) * a * a + 1) + b
        },
        easeInOutCubic: function(c, a, b, d, e) {
            if ((a /= e / 2) < 1) return d / 2 * a * a * a + b;
            return d / 2 * ((a -= 2) * a * a + 2) + b
        },
        easeInQuart: function(c, a, b, d, e) {
            return d * (a /= e) * a * a * a + b
        },
        easeOutQuart: function(c, a, b, d, e) {
            return -d * ((a = a / e - 1) * a * a * a - 1) + b
        },
        easeInOutQuart: function(c, a, b, d, e) {
            if ((a /= e / 2) < 1) return d / 2 * a * a * a * a + b;
            return -d / 2 * ((a -= 2) * a * a * a - 2) + b
        },
        easeInQuint: function(c, a, b, d, e) {
            return d * (a /= e) * a * a * a * a + b
        },
        easeOutQuint: function(c, a, b, d, e) {
            return d * ((a = a / e - 1) * a * a * a * a + 1) + b
        },
        easeInOutQuint: function(c, a, b, d, e) {
            if ((a /= e / 2) < 1) return d / 2 * a * a * a * a * a + b;
            return d / 2 * ((a -= 2) * a * a * a * a + 2) + b
        },
        easeInSine: function(c, a, b, d, e) {
            return -d * Math.cos(a / e * (Math.PI / 2)) + d + b
        },
        easeOutSine: function(c, a, b, d, e) {
            return d * Math.sin(a / e * (Math.PI / 2)) + b
        },
        easeInOutSine: function(c, a, b, d, e) {
            return -d / 2 * (Math.cos(Math.PI * a / e) - 1) + b
        },
        easeInExpo: function(c, a, b, d, e) {
            return a == 0 ? b : d * Math.pow(2, 10 * (a / e - 1)) + b
        },
        easeOutExpo: function(c, a, b, d, e) {
            return a == e ? b + d : d * (-Math.pow(2, -10 * a / e) + 1) + b
        },
        easeInOutExpo: function(c, a, b, d, e) {
            if (a == 0) return b;
            if (a == e) return b + d;
            if ((a /= e / 2) < 1) return d / 2 * Math.pow(2, 10 * (a - 1)) + b;
            return d / 2 * (-Math.pow(2, -10 * --a) + 2) + b
        },
        easeInCirc: function(c, a, b, d, e) {
            return -d * (Math.sqrt(1 - (a /= e) * a) - 1) + b
        },
        easeOutCirc: function(c, a, b, d, e) {
            return d * Math.sqrt(1 - (a = a / e - 1) * a) + b
        },
        easeInOutCirc: function(c, a, b, d, e) {
            if ((a /= e / 2) < 1) return -d / 2 * (Math.sqrt(1 - a * a) - 1) + b;
            return d / 2 * (Math.sqrt(1 - (a -= 2) * a) + 1) + b
        },
        easeInElastic: function(c, a, b, d, e) {
            c = 1.70158;
            var g = 0,
                h = d;
            if (a == 0) return b;
            if ((a /= e) == 1) return b + d;
            g || (g = e * 0.3);
            if (h < Math.abs(d)) {
                h = d;
                c = g / 4
            } else c = g / (2 * Math.PI) * Math.asin(d / h);
            return -(h * Math.pow(2, 10 * (a -= 1)) * Math.sin((a * e - c) * 2 * Math.PI / g)) + b
        },
        easeOutElastic: function(c, a, b, d, e) {
            c = 1.70158;
            var g = 0,
                h = d;
            if (a == 0) return b;
            if ((a /= e) == 1) return b + d;
            g || (g = e * 0.3);
            if (h < Math.abs(d)) {
                h = d;
                c = g / 4
            } else c = g / (2 * Math.PI) * Math.asin(d / h);
            return h * Math.pow(2, -10 * a) * Math.sin((a * e - c) * 2 * Math.PI / g) + d + b
        },
        easeInOutElastic: function(c, a, b, d, e) {
            c = 1.70158;
            var g = 0,
                h = d;
            if (a == 0) return b;
            if ((a /= e / 2) == 2) return b + d;
            g || (g = e * 0.3 * 1.5);
            if (h < Math.abs(d)) {
                h = d;
                c = g / 4
            } else c = g / (2 * Math.PI) * Math.asin(d / h);
            if (a < 1) return -0.5 * h * Math.pow(2, 10 * (a -= 1)) * Math.sin((a * e - c) * 2 * Math.PI / g) + b;
            return h * Math.pow(2, -10 * (a -= 1)) * Math.sin((a * e - c) * 2 * Math.PI / g) * 0.5 + d + b
        },
        easeInBack: function(c, a, b, d, e, g) {
            if (g == j) g = 1.70158;
            return d * (a /= e) * a * ((g + 1) * a - g) + b
        },
        easeOutBack: function(c, a, b, d, e, g) {
            if (g == j) g = 1.70158;
            return d * ((a = a / e - 1) * a * ((g + 1) * a + g) + 1) + b
        },
        easeInOutBack: function(c, a, b, d, e, g) {
            if (g == j) g = 1.70158;
            if ((a /= e / 2) < 1) return d / 2 * a * a * (((g *= 1.525) + 1) * a - g) + b;
            return d / 2 * ((a -= 2) * a * (((g *= 1.525) + 1) * a + g) + 2) + b
        },
        easeInBounce: function(c, a, b, d, e) {
            return d - f.easing.easeOutBounce(c, e - a, 0, d, e) + b
        },
        easeOutBounce: function(c, a, b, d, e) {
            return (a /= e) < 1 / 2.75 ? d * 7.5625 * a * a + b : a < 2 / 2.75 ? d * (7.5625 * (a -= 1.5 / 2.75) * a + 0.75) + b : a < 2.5 / 2.75 ? d * (7.5625 * (a -= 2.25 / 2.75) * a + 0.9375) + b : d * (7.5625 * (a -= 2.625 / 2.75) * a + 0.984375) + b
        },
        easeInOutBounce: function(c, a, b, d, e) {
            if (a < e / 2) return f.easing.easeInBounce(c, a * 2, 0, d, e) * 0.5 + b;
            return f.easing.easeOutBounce(c, a * 2 - e, 0, d, e) * 0.5 + d * 0.5 + b
        }
    })
}(jQuery);;
/*
 * jQuery UI selectmenu version 1.1.0
 *
 * Copyright (c) 2009 AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT (MIT-LICENSE.txt)
 * and GPL (GPL-LICENSE.txt) licenses.
 *
 * http://docs.jquery.com/UI
 * https://github.com/fnagel/jquery-ui/wiki/Selectmenu
 */ (function(d) {
    d.widget("ui.selectmenu", {
        getter: "value",
        version: "1.8",
        eventPrefix: "selectmenu",
        options: {
            transferClasses: !0,
            typeAhead: "sequential",
            style: "dropdown",
            positionOptions: {
                my: "left top",
                at: "left bottom",
                offset: null
            },
            width: null,
            menuWidth: null,
            handleWidth: 26,
            maxHeight: null,
            icons: null,
            format: null,
            bgImage: function() {},
            wrapperElement: ""
        },
        _create: function() {
            var a = this,
                b = this.options,
                e = this.element.attr("id") || "ui-selectmenu-" + Math.random().toString(16).slice(2, 10);
            this.title = this.element.attr("title");
            this.ids = [e + "-button", e + "-menu"];
            this._safemouseup = !0;
            this.newelement = d('<a class="' + this.widgetBaseClass + ' ui-widget ui-state-default ui-corner-all" id="' + this.ids[0] + '" role="button" href="#" tabindex="0" aria-haspopup="true" aria-owns="' + this.ids[1] + '"></a>').insertAfter(this.element);
            this.newelement.wrap(b.wrapperElement);
            (e = this.element.attr("tabindex")) && this.newelement.attr("tabindex", e);
            this.newelement.data("selectelement", this.element);
            this.selectmenuIcon = d('<span class="' + this.widgetBaseClass + '-icon ui-icon"></span>').prependTo(this.newelement);
            this.newelement.prepend('<span class="' + a.widgetBaseClass + '-status" />');
            d('label[for="' + this.element.attr("id") + '"]').attr("for", this.ids[0]).bind("click.selectmenu", function() {
                a.newelement[0].focus();
                return !1
            });
            this.newelement.bind("mousedown.selectmenu", function(d) {
                a._toggle(d, !0);
                if (b.style == "popup") a._safemouseup = !1, setTimeout(function() {
                    a._safemouseup = !0
                }, 300);
                return !1
            }).bind("click.selectmenu", function() {
                return !1
            }).bind("keydown.selectmenu", function(b) {
                var e = !1;
                switch (b.keyCode) {
                case d.ui.keyCode.ENTER:
                    e = !0;
                    break;
                case d.ui.keyCode.SPACE:
                    a._toggle(b);
                    break;
                case d.ui.keyCode.UP:
                    b.altKey ? a.open(b) : a._moveSelection(-1);
                    break;
                case d.ui.keyCode.DOWN:
                    b.altKey ? a.open(b) : a._moveSelection(1);
                    break;
                case d.ui.keyCode.LEFT:
                    a._moveSelection(-1);
                    break;
                case d.ui.keyCode.RIGHT:
                    a._moveSelection(1);
                    break;
                case d.ui.keyCode.TAB:
                    e = !0;
                    break;
                default:
                    e = !0
                }
                return e
            }).bind("keypress.selectmenu", function(b) {
                a._typeAhead(b.which, "mouseup");
                return !0
            }).bind("mouseover.selectmenu focus.selectmenu", function() {
                b.disabled || d(this).addClass(a.widgetBaseClass + "-focus ui-state-hover")
            }).bind("mouseout.selectmenu blur.selectmenu", function() {
                b.disabled || d(this).removeClass(a.widgetBaseClass + "-focus ui-state-hover")
            });
            d(document).bind("mousedown.selectmenu", function(b) {
                a.close(b)
            });
            this.element.bind("click.selectmenu", function() {
                a._refreshValue()
            }).bind("focus.selectmenu", function() {
                a.newelement && a.newelement[0].focus()
            });
            if (!b.width) b.width = this.element.outerWidth();
            this.newelement.width(b.width);
            this.element.hide();
            this.list = d('<ul class="' + a.widgetBaseClass + '-menu ui-widget ui-widget-content" aria-hidden="true" role="listbox" aria-labelledby="' + this.ids[0] + '" id="' + this.ids[1] + '"></ul>').appendTo("body");
            this.list.wrap(b.wrapperElement);
            this.list.bind("keydown.selectmenu", function(b) {
                var e = !1;
                switch (b.keyCode) {
                case d.ui.keyCode.UP:
                    b.altKey ? a.close(b, !0) : a._moveFocus(-1);
                    break;
                case d.ui.keyCode.DOWN:
                    b.altKey ? a.close(b, !0) : a._moveFocus(1);
                    break;
                case d.ui.keyCode.LEFT:
                    a._moveFocus(-1);
                    break;
                case d.ui.keyCode.RIGHT:
                    a._moveFocus(1);
                    break;
                case d.ui.keyCode.HOME:
                    a._moveFocus(":first");
                    break;
                case d.ui.keyCode.PAGE_UP:
                    a._scrollPage("up");
                    break;
                case d.ui.keyCode.PAGE_DOWN:
                    a._scrollPage("down");
                    break;
                case d.ui.keyCode.END:
                    a._moveFocus(":last");
                    break;
                case d.ui.keyCode.ENTER:
                case d.ui.keyCode.SPACE:
                    a.close(b, !0);
                    d(b.target).parents("li:eq(0)").trigger("mouseup");
                    break;
                case d.ui.keyCode.TAB:
                    e = !0;
                    a.close(b, !0);
                    d(b.target).parents("li:eq(0)").trigger("mouseup");
                    break;
                case d.ui.keyCode.ESCAPE:
                    a.close(b, !0);
                    break;
                default:
                    e = !0
                }
                return e
            }).bind("keypress.selectmenu", function(b) {
                a._typeAhead(b.which, "focus");
                return !0
            }).bind("mousedown.selectmenu mouseup.selectmenu", function() {
                return !1
            });
            d(window).bind("resize.selectmenu", d.proxy(a._refreshPosition, this))
        },
        _init: function() {
            var a = this,
                b = this.options,
                e = [];
            this.element.find("option").each(function() {
                e.push({
                    value: d(this).attr("value"),
                    text: a._formatText(d(this).text()),
                    selected: d(this).attr("selected"),
                    disabled: d(this).attr("disabled"),
                    classes: d(this).attr("class"),
                    typeahead: d(this).attr("typeahead"),
                    parentOptGroup: d(this).parent("optgroup"),
                    bgImage: b.bgImage.call(d(this))
                })
            });
            var h = a.options.style == "popup" ? " ui-state-active" : "";
            this.list.html("");
            for (var f = 0; f < e.length; f++) {
                var g = d('<li role="presentation"' + (e[f].disabled ? ' class="' + this.namespace + '-state-disabled"' : "") + '><a href="#" tabindex="-1" role="option"' + (e[f].disabled ? ' aria-disabled="true"' : "") + ' aria-selected="false"' + (e[f].typeahead ? ' typeahead="' + e[f].typeahead + '"' : "") + ">" + e[f].text + "</a></li>").data("index", f).addClass(e[f].classes).data("optionClasses", e[f].classes || "").bind("mouseup.selectmenu", function(b) {
                    if (a._safemouseup && !a._disabled(b.currentTarget) && !a._disabled(d(b.currentTarget).parents("ul>li." + a.widgetBaseClass + "-group "))) {
                        var e = d(this).data("index") != a._selectedIndex();
                        a.index(d(this).data("index"));
                        a.select(b);
                        e && a.change(b);
                        a.close(b, !0)
                    }
                    return !1
                }).bind("click.selectmenu", function() {
                    return !1
                }).bind("mouseover.selectmenu focus.selectmenu", function(b) {
                    d(b.currentTarget).hasClass(a.namespace + "-state-disabled") || (a._selectedOptionLi().addClass(h), a._focusedOptionLi().removeClass(a.widgetBaseClass + "-item-focus ui-state-hover"), d(this).removeClass("ui-state-active").addClass(a.widgetBaseClass + "-item-focus ui-state-hover"))
                }).bind("mouseout.selectmenu blur.selectmenu", function() {
                    d(this).is(a._selectedOptionLi().selector) && d(this).addClass(h);
                    d(this).removeClass(a.widgetBaseClass + "-item-focus ui-state-hover")
                });
                if (e[f].parentOptGroup.length) {
                    var i = a.widgetBaseClass + "-group-" + this.element.find("optgroup").index(e[f].parentOptGroup);
                    this.list.find("li." + i).length ? this.list.find("li." + i + ":last ul").append(g) : d(' <li role="presentation" class="' + a.widgetBaseClass + "-group " + i + (e[f].parentOptGroup.attr("disabled") ? " " + this.namespace + '-state-disabled" aria-disabled="true"' : '"') + '><span class="' + a.widgetBaseClass + '-group-label">' + e[f].parentOptGroup.attr("label") + "</span><ul></ul></li> ").appendTo(this.list).find("ul").append(g)
                } else g.appendTo(this.list);
                if (b.icons) for (var j in b.icons) g.is(b.icons[j].find) && (g.data("optionClasses", e[f].classes + " " + a.widgetBaseClass + "-hasIcon").addClass(a.widgetBaseClass + "-hasIcon"), i = b.icons[j].icon || "", g.find("a:eq(0)").prepend('<span class="' + a.widgetBaseClass + "-item-icon ui-icon " + i + '"></span>'), e[f].bgImage && g.find("span").css("background-image", e[f].bgImage))
            }
            f = b.style == "dropdown";
            this.newelement.toggleClass(a.widgetBaseClass + "-dropdown", f).toggleClass(a.widgetBaseClass + "-popup", !f);
            this.list.toggleClass(a.widgetBaseClass + "-menu-dropdown ui-corner-bottom", f).toggleClass(a.widgetBaseClass + "-menu-popup ui-corner-all", !f).find("li:first").toggleClass("ui-corner-top", !f).end().find("li:last").addClass("ui-corner-bottom");
            this.selectmenuIcon.toggleClass("ui-icon-triangle-1-s", f).toggleClass("ui-icon-triangle-2-n-s", !f);
            b.transferClasses && (f = this.element.attr("class") || "", this.newelement.add(this.list).addClass(f));
            b.style == "dropdown" ? this.list.width(b.menuWidth ? b.menuWidth : b.width) : this.list.width(b.menuWidth ? b.menuWidth : b.width - b.handleWidth);
            if (b.maxHeight) b.maxHeight < this.list.height() && this.list.height(b.maxHeight);
            else if (!b.format && d(window).height() / 3 < this.list.height()) b.maxHeight = d(window).height() / 3, this.list.height(b.maxHeight);
            this._optionLis = this.list.find("li:not(." + a.widgetBaseClass + "-group)");
            this.element.attr("disabled") === !0 ? this.disable() : this.enable();
            this.index(this._selectedIndex());
            window.setTimeout(function() {
                a._refreshPosition()
            }, 200)
        },
        destroy: function() {
            this.element.removeData(this.widgetName).removeClass(this.widgetBaseClass + "-disabled " + this.namespace + "-state-disabled").removeAttr("aria-disabled").unbind(".selectmenu");
            d(window).unbind(".selectmenu");
            d(document).unbind(".selectmenu");
            d("label[for=" + this.newelement.attr("id") + "]").attr("for", this.element.attr("id")).unbind(".selectmenu");
            this.options.wrapperElement ? (this.newelement.find(this.options.wrapperElement).remove(), this.list.find(this.options.wrapperElement).remove()) : (this.newelement.remove(), this.list.remove());
            this.element.show();
            d.Widget.prototype.destroy.apply(this, arguments)
        },
        _typeAhead: function(a, b) {
            var e = this,
                h = !1,
                f = String.fromCharCode(a).toUpperCase();
            c = f.toLowerCase();
            if (e.options.typeAhead == "sequential") {
                window.clearTimeout("ui.selectmenu-" + e.selectmenuId);
                var g = typeof e._prevChar == "undefined" ? "" : e._prevChar.join(""),
                    i = function(a, f, g) {
                        h = !0;
                        d(a).trigger(b);
                        typeof e._prevChar == "undefined" ? e._prevChar = [g] : e._prevChar[e._prevChar.length] = g
                    };
                this.list.find("li a").each(function(a) {
                    if (!h) {
                        var b = d(this).attr("typeahead") || d(this).text();
                        b.indexOf(g + f) == 0 ? i(this, a, f) : b.indexOf(g + c) == 0 && i(this, a, c)
                    }
                });
                window.setTimeout(function() {
                    e._prevChar = void 0
                }, 1E3, e)
            } else {
                if (!e._prevChar) e._prevChar = ["", 0];
                h = !1;
                this.list.find("li a").each(function(a) {
                    if (!h) {
                        var g = d(this).text();
                        if (g.indexOf(f) == 0 || g.indexOf(c) == 0) e._prevChar[0] == f ? e._prevChar[1] < a && (h = !0, d(this).trigger(b), e._prevChar[1] = a) : (h = !0, d(this).trigger(b), e._prevChar[1] = a)
                    }
                });
                this._prevChar[0] = f
            }
        },
        _uiHash: function() {
            var a = this.index();
            return {
                index: a,
                option: d("option", this.element).get(a),
                value: this.element[0].value
            }
        },
        open: function(a) {
            this.newelement.attr("aria-disabled") != "true" && (this._closeOthers(a), this.newelement.addClass("ui-state-active"), this.options.wrapperElement ? this.list.parent().appendTo("body") : this.list.appendTo("body"), this.list.addClass(this.widgetBaseClass + "-open").attr("aria-hidden", !1).find("li:not(." + this.widgetBaseClass + "-group):eq(" + this._selectedIndex() + ") a")[0].focus(), this.options.style == "dropdown" && this.newelement.removeClass("ui-corner-all").addClass("ui-corner-top"), this._refreshPosition(), this._trigger("open", a, this._uiHash()))
        },
        close: function(a, b) {
            this.newelement.is(".ui-state-active") && (this.newelement.removeClass("ui-state-active"), this.list.attr("aria-hidden", !0).removeClass(this.widgetBaseClass + "-open"), this.options.style == "dropdown" && this.newelement.removeClass("ui-corner-top").addClass("ui-corner-all"), b && this.newelement.focus(), this._trigger("close", a, this._uiHash()))
        },
        change: function(a) {
            this.element.trigger("change");
            this._trigger("change", a, this._uiHash())
        },
        select: function(a) {
            if (this._disabled(a.currentTarget)) return !1;
            this._trigger("select", a, this._uiHash())
        },
        _closeOthers: function(a) {
            d("." + this.widgetBaseClass + ".ui-state-active").not(this.newelement).each(function() {
                d(this).data("selectelement").selectmenu("close", a)
            });
            d("." + this.widgetBaseClass + ".ui-state-hover").trigger("mouseout")
        },
        _toggle: function(a, b) {
            this.list.is("." + this.widgetBaseClass + "-open") ? this.close(a, b) : this.open(a)
        },
        _formatText: function(a) {
            return this.options.format ? this.options.format(a) : a
        },
        _selectedIndex: function() {
            return this.element[0].selectedIndex
        },
        _selectedOptionLi: function() {
            return this._optionLis.eq(this._selectedIndex())
        },
        _focusedOptionLi: function() {
            return this.list.find("." + this.widgetBaseClass + "-item-focus")
        },
        _moveSelection: function(a, b) {
            var e = parseInt(this._selectedOptionLi().data("index") || 0, 10) + a;
            e < 0 && (e = 0);
            e > this._optionLis.size() - 1 && (e = this._optionLis.size() - 1);
            if (e === b) return !1;
            if (this._optionLis.eq(e).hasClass(this.namespace + "-state-disabled")) a > 0 ? ++a : --a, this._moveSelection(a, e);
            else return this._optionLis.eq(e).trigger("mouseup")
        },
        _moveFocus: function(a, b) {
            var e = isNaN(a) ? parseInt(this._optionLis.filter(a).data("index"), 10) : parseInt(this._focusedOptionLi().data("index") || 0, 10) + a;
            e < 0 && (e = 0);
            e > this._optionLis.size() - 1 && (e = this._optionLis.size() - 1);
            if (e === b) return !1;
            var d = this.widgetBaseClass + "-item-" + Math.round(Math.random() * 1E3);
            this._focusedOptionLi().find("a:eq(0)").attr("id", "");
            this._optionLis.eq(e).hasClass(this.namespace + "-state-disabled") ? (a > 0 ? ++a : --a, this._moveFocus(a, e)) : this._optionLis.eq(e).find("a:eq(0)").attr("id", d).focus();
            this.list.attr("aria-activedescendant", d)
        },
        _scrollPage: function(a) {
            var b = Math.floor(this.list.outerHeight() / this.list.find("li:first").outerHeight());
            this._moveFocus(a == "up" ? -b : b)
        },
        _setOption: function(a, b) {
            this.options[a] = b;
            a == "disabled" && (this.close(), this.element.add(this.newelement).add(this.list)[b ? "addClass" : "removeClass"](this.widgetBaseClass + "-disabled " + this.namespace + "-state-disabled").attr("aria-disabled", b))
        },
        disable: function(a, b) {
            typeof a == "undefined" ? this._setOption("disabled", !0) : b == "optgroup" ? this._disableOptgroup(a) : this._disableOption(a)
        },
        enable: function(a, b) {
            typeof a == "undefined" ? this._setOption("disabled", !1) : b == "optgroup" ? this._enableOptgroup(a) : this._enableOption(a)
        },
        _disabled: function(a) {
            return d(a).hasClass(this.namespace + "-state-disabled")
        },
        _disableOption: function(a) {
            var b = this._optionLis.eq(a);
            b && (b.addClass(this.namespace + "-state-disabled").find("a").attr("aria-disabled", !0), this.element.find("option").eq(a).attr("disabled", "disabled"))
        },
        _enableOption: function(a) {
            var b = this._optionLis.eq(a);
            b && (b.removeClass(this.namespace + "-state-disabled").find("a").attr("aria-disabled", !1), this.element.find("option").eq(a).removeAttr("disabled"))
        },
        _disableOptgroup: function(a) {
            var b = this.list.find("li." + this.widgetBaseClass + "-group-" + a);
            b && (b.addClass(this.namespace + "-state-disabled").attr("aria-disabled", !0), this.element.find("optgroup").eq(a).attr("disabled", "disabled"))
        },
        _enableOptgroup: function(a) {
            var b = this.list.find("li." + this.widgetBaseClass + "-group-" + a);
            b && (b.removeClass(this.namespace + "-state-disabled").attr("aria-disabled", !1), this.element.find("optgroup").eq(a).removeAttr("disabled"))
        },
        index: function(a) {
            if (arguments.length) if (this._disabled(d(this._optionLis[a]))) return !1;
            else this.element[0].selectedIndex = a, this._refreshValue();
            else return this._selectedIndex()
        },
        value: function(a) {
            if (arguments.length) this.element[0].value = a, this._refreshValue();
            else return this.element[0].value
        },
        _refreshValue: function() {
            var a = this.options.style == "popup" ? " ui-state-active" : "",
                b = this.widgetBaseClass + "-item-" + Math.round(Math.random() * 1E3);
            this.list.find("." + this.widgetBaseClass + "-item-selected").removeClass(this.widgetBaseClass + "-item-selected" + a).find("a").attr("aria-selected", "false").attr("id", "");
            this._selectedOptionLi().addClass(this.widgetBaseClass + "-item-selected" + a).find("a").attr("aria-selected", "true").attr("id", b);
            var a = this.newelement.data("optionClasses") ? this.newelement.data("optionClasses") : "",
                e = this._selectedOptionLi().data("optionClasses") ? this._selectedOptionLi().data("optionClasses") : "",
                d;
            this.title ? (d = this.title, this.title = null) : d = this._selectedOptionLi().find("a:eq(0)").html();
            this.newelement.removeClass(a).data("optionClasses", e).addClass(e).find("." + this.widgetBaseClass + "-status").html(d);
            this.list.attr("aria-activedescendant", b)
        },
        _refreshPosition: function() {
            var a = this.options;
            if (a.style == "popup" && !a.positionOptions.offset) var b = this._selectedOptionLi(),
                b = "0 -" + (b.outerHeight() + b.offset().top - this.list.offset().top);
            var d = this.element.zIndex();
            d && this.list.css({
                zIndex: d
            });
            this.list.position({
                of: a.positionOptions.of || this.newelement,
                my: a.positionOptions.my,
                at: a.positionOptions.at,
                offset: a.positionOptions.offset || b,
                collision: a.positionOptions.collision || "flip"
            })
        }
    })
})(jQuery);

/*
 * jQuery UI Checkbox 0.1
 *
 * Copyright (c) 2009 Jeremy Lea <reg@openpave.org>
 * Dual licensed under the MIT and GPL licenses.
 *
 * http://docs.jquery.com/Licensing
 *
 * Based loosely on plugin by alexander.farkas.
 * http://www.protofunc.com/scripts/jquery/checkbox-radiobutton/
 *
 * Label, id and title handling by Bela Gabor Zakar <zbacsi@gmail.com>
 */ (function(b) {
    if (b.browser.msie) {
        try {
            document.execCommand("BackgroundImageCache", !1, !0)
        } catch (g) {}
        document.namespaces.v || (b("head").prepend("<xml:namespace ns='urn:schemas-microsoft-com:vml' prefix='v' />"), b("head").prepend("<?import namespace='v' implementation='#default#VML' ?>"))
    }
    b.widget("ui.checkbox", {
        _init: function() {
            if (!this.element.is(":radio,:checkbox")) return !1;
            this._radio = this.element.is(":radio") ? b(this.element[0].form).find("input:radio").filter('[name="' + this.element[0].name + '"]') : !1;
            var a = this,
                c = this.options;
            this.element.attr({
                role: this._radio ? "radio" : "checkbox",
                "aria-checked": !! this.element[0].checked
            });
            this._wrapper = this.element.wrap(b("<span />")).parent().addClass((this._radio ? "ui-radio" : "ui-checkbox") + " ui-state-default").attr({
                title: b(this.element).attr("title")
            });
            this._wrapper.prepend(b("<span/>").addClass("ui-icon " + this._icon(!1)).click(function(b) {
                a.element[0].click();
                b.preventDefault();
                b.stopImmediatePropagation();
                return !1
            }));
            b("label[for=" + this.element.attr("id") + "]").click(function(b) {
                a.element[0].click();
                b.preventDefault();
                b.stopImmediatePropagation();
                return !1
            });
            if (b.browser.msie) {
                this._wrapper[0].insertAdjacentHTML("afterBegin", "<v:roundrect arcsize='" + (this._radio ? "1" : "0.1") + "'><v:stroke /><v:fill /></v:roundrect>");
                this._vml = this._wrapper[0].childNodes[0];
                var d = this._wrapper[0].currentStyle;
                this._vml.style.top = "-1px";
                this._vml.style.left = "-1px";
                this._vml.style.width = parseInt(d.width) + 1 + "px";
                this._vml.style.height = parseInt(d.height) + 1 + "px";
                this._doVML();
                this._vml.style.visibility = "visible";
                this._wrapper.css("visibility", "hidden");
                this._wrapper[0].onpropertychange = function() {
                    switch (event.propertyName) {
                    case "className":
                    case "style.borderTopWidth":
                    case "style.borderTopColor":
                    case "style.backgroundColor":
                    case "style.filter":
                        a._doVML()
                    }
                };
                b().bind("ui-theme-switch", function() {
                    setTimeout(function() {
                        a._doVML()
                    }, 500);
                    return !1
                })
            }
            if (b.browser.opera) {
                var f = document.createElementNS("http://www.w3.org/2000/svg", "svg"),
                    e = document.createElementNS("http://www.w3.org/2000/svg", "rect"),
                    d = this._wrapper[0].currentStyle;
                e.setAttributeNS(null, "x", "1px");
                e.setAttributeNS(null, "y", "1px");
                e.setAttributeNS(null, "width", d.width);
                e.setAttributeNS(null, "height", d.height);
                e.setAttributeNS(null, "rx", this._radio ? "6px" : "2px");
                f.appendChild(e);
                this._wrapper.prepend(f);
                this._svg = this._wrapper[0].firstChild;
                this._svg.style.width = parseInt(d.width) + 2 + "px";
                this._svg.style.height = parseInt(d.height) + 2 + "px";
                this._doSVG();
                this._svg.style.visibility = "visible";
                this._wrapper.css("visibility", "hidden");
                this._wrapper.bind("DOMAttrModified", function(b) {
                    b.attrName === "class" && a._doSVG()
                });
                b().bind("ui-theme-switch", function() {
                    a._doSVG();
                    return !1
                })
            }
            this._wrapper.hover(function() {
                c.disabled || b(this).addClass("ui-state-hover")
            }, function() {
                c.disabled || b(this).removeClass("ui-state-hover")
            }).bind("mousedown", function() {
                c.disabled || b(this).addClass("ui-state-active")
            }).bind("mouseup", function() {
                c.disabled || b(this).removeClass("ui-state-active")
            }).bind(this.widgetEventPrefix + "focus", function() {
                c.disabled || (a._radio && a._radio.not(a.element).removeClass("ui-state-focus"), b(this).addClass("ui-state-focus"))
            }).bind(this.widgetEventPrefix + "blur", function() {
                c.disabled || b(this).removeClass("ui-state-focus")
            }).bind(this.widgetEventPrefix + "click", function() {
                c.disabled || (a._radio ? (a._radio.not(a.element).checkbox("uncheck"), a.check()) : a.toggle())
            });
            this.element.bind("focus." + this.widgetName, function(b) {
                a._trigger("focus", b)
            }).bind("blur." + this.widgetName, function(b) {
                a._trigger("blur", b)
            }).bind("click." + this.widgetName, function(b) {
                a._trigger("click", b)
            });
            this._setData("checked", !! this.element[0].checked)
        },
        destroy: function() {
            this._wrapper.replaceWith(this.element);
            this.element.removeAttr("role").removeAttr("aria-checked").unbind("." + this.widgetName);
            b.widget.prototype.destroy.apply(this, arguments)
        },
        _setData: function(a, c) {
            b(this).data(a, c);
            if (a == "disabled") c ? (this.element.attr("disabled", "disabled"), this._wrapper.removeClass("ui-state-focus ui-state-hover ui-state-active")) : this.element.removeAttr("disabled"), this._wrapper[c ? "addClass" : "removeClass"](this.widgetName + "-disabled " + this.namespace + "-state-disabled");
            else if (a == "checked") this.element[0].checked = !! c, this.element.attr("aria-checked", !! c), this._wrapper.find(".ui-icon").addClass(this._icon( !! c)).removeClass(this._icon(!c))
        },
        check: function() {
            this._setData("checked", !0)
        },
        uncheck: function() {
            this._setData("checked", !1)
        },
        toggle: function() {
            this._setData("checked", !b(this).data("checked"))
        },
        _icon: function(a) {
            if (this._radio) return "ui-icon-" + this.options[a ? "radioChecked" : "radioUnchecked"];
            else {
                if (a) return "ui-icon-check";
                return "ui-icon-empty"
            }
        },
        _opacityFixed: !1,
        _inFixup: !1,
        _fixStyle: function(a, b) {
            var d = a.attr("style").replace(b, "");
            d !== "" ? a.attr("style", d) : a.removeAttr("style")
        },
        _doVML: function() {
            if (this._vml && !this._inFixup) {
                this._inFixup = !0;
                var a, b;
                if (this._opacityFixed) this._vml.childNodes[0].opacity = "1", this._vml.childNodes[1].opacity = "1", this._fixStyle(this._wrapper.find(".ui-icon"), /filter[^;]*\;?/i), this._fixStyle(this._wrapper, /filter[^;]*\;?/i), this._opacityFixed = !1;
                a = this._wrapper[0].currentStyle;
                this._vml.strokecolor = a.borderTopColor;
                this._vml.strokeweight = a.borderTopWidth;
                this._vml.fillcolor = a.backgroundColor;
                this._vml.childNodes[0].color = a.borderTopColor;
                this._vml.childNodes[0].weight = a.borderTopWidth;
                this._vml.childNodes[1].color = a.backgroundColor;
                if (a.filter && a.filter.search(/Alpha/i) !== -1) b = /(\d+)/.exec(a.filter), this._wrapper.find(".ui-icon").css("filter", a.filter), this._vml.childNodes[0].opacity = b[1] / 100, this._vml.childNodes[1].opacity = b[1] / 100, this._wrapper.css("filter", ""), this._opacityFixed = !0;
                this._inFixup = !1
            }
        },
        _doSVG: function() {
            if (this._svg && !this._inFixup) {
                this._inFixup = !0;
                var a;
                if (this._opacityFixed) this._fixStyle(this._wrapper.find(".ui-icon"), /opacity[^;]*\;?/i), this._fixStyle(this._wrapper.find("rect"), /opacity[^;]*\;?/i), this._fixStyle(this._wrapper, /opacity[^;]*\;?/i), this._opacityFixed = !1;
                a = this._wrapper[0].currentStyle;
                this._svg.firstChild.style.stroke = a.borderTopColor;
                this._svg.firstChild.style.strokeWidth = a.borderTopWidth;
                this._svg.firstChild.style.fill = a.backgroundColor;
                if (a.opacity && a.opacity !== 1) a = a.opacity, this._wrapper.find(".ui-icon").css("opacity", a), this._wrapper.find("rect").css("opacity", a), this._wrapper[0].style.opacity = "1", this._opacityFixed = !0;
                this._inFixup = !1
            }
        }
    });
    b.ui.checkbox.defaults = {
        checkboxChecked: "check",
        checkboxUnchecked: "empty",
        radioChecked: "bullet",
        radioUnchecked: "empty"
    }
})(jQuery);